	dhlDetailsWindow = new Array(); 
	function dhlDetails(entry){
		$_ = displayedNumbers[entry];
		
		dhlDetailsWindow[entry] = new Array();
		dhlDetailsWindow[entry]["Container"] = new Window("details"+entry);
		dhlDetailsWindow[entry]["Container"].height = 300;
		dhlDetailsWindow[entry]["Container"].width  = 300;
		dhlDetailsWindow[entry]["Container"].visible = 1;

		dhlDetailsWindow[entry]["BackgroundTop"] = new Image(dhlDetailsWindow[entry]["Container"]);
		dhlDetailsWindow[entry]["BackgroundTop"].width    = dhlDetailsWindow[entry]["Container"].width;
		dhlDetailsWindow[entry]["BackgroundTop"].height   = 10;
		dhlDetailsWindow[entry]["BackgroundTop"].src      = "./Resources/backgroundTop.png";
		dhlDetailsWindow[entry]["BackgroundTop"].colorize = preferences.bezelColor.value;

		dhlDetailsWindow[entry]["BackgroundCenter"] = new Image(dhlDetailsWindow[entry]["Container"]);
		dhlDetailsWindow[entry]["BackgroundCenter"].width    = dhlDetailsWindow[entry]["Container"].width;
		dhlDetailsWindow[entry]["BackgroundCenter"].height   = 280;
		dhlDetailsWindow[entry]["BackgroundCenter"].src      = "./Resources/backgroundCenter.png";
		dhlDetailsWindow[entry]["BackgroundCenter"].colorize = preferences.bezelColor.value;
		dhlDetailsWindow[entry]["BackgroundCenter"].vOffset  = dhlDetailsWindow[entry]["BackgroundTop"].vOffset + dhlDetailsWindow[entry]["BackgroundTop"].height;

		dhlDetailsWindow[entry]["BackgroundBottom"] = new Image(dhlDetailsWindow[entry]["Container"]);
		dhlDetailsWindow[entry]["BackgroundBottom"].width    = dhlDetailsWindow[entry]["Container"].width;
		dhlDetailsWindow[entry]["BackgroundBottom"].height   = 10;
		dhlDetailsWindow[entry]["BackgroundBottom"].src      = "./Resources/backgroundBottom.png";
		dhlDetailsWindow[entry]["BackgroundBottom"].colorize = preferences.bezelColor.value;	
		dhlDetailsWindow[entry]["BackgroundBottom"].vOffset  = dhlDetailsWindow[entry]["BackgroundCenter"].vOffset + dhlDetailsWindow[entry]["BackgroundCenter"].height;

		dhlDetailsWindow[entry]["Details"] = new TextArea(dhlDetailsWindow[entry]["Container"]);
		dataStr = "";
		for (items in displayedNumbers[entry]){
		$_ = displayedNumbers[entry][items];
			if (($_ != "Unavailable")
			  &&(items != "itemFrame") 
			  &&(items != "position")
			  &&(items != "readout"))
			{
				dataStr += resolveNumValue(items) +": "+$_+"\n";
			}
		}
		dhlDetailsWindow[entry]["Details"].data	   = dataStr;
		dhlDetailsWindow[entry]["Details"].font    = "Verdana";
		dhlDetailsWindow[entry]["Details"].color   = preferences.fontColor.value;
		dhlDetailsWindow[entry]["Details"].size    = 12;
		dhlDetailsWindow[entry]["Details"].hOffset = 10;
		dhlDetailsWindow[entry]["Details"].vOffset = 10;
		dhlDetailsWindow[entry]["Details"].width   = 286;
		dhlDetailsWindow[entry]["Details"].height  = 270;
		dhlDetailsWindow[entry]["Details"].editable = 0;
		if (dataStr.split("\n").length > 18){
			dhlDetailsWindow[entry]["Details"].scrollbar = "";
			dhlDetailsWindow[entry]["Details"].scrollbar = 1;		
		} else{
			dhlDetailsWindow[entry]["Details"].scrollbar = "";
			dhlDetailsWindow[entry]["Details"].scrollbar = 0;
		}


		dhlDetailsWindow[entry]["Close"] = new Image(dhlDetailsWindow[entry]["Container"]);
		dhlDetailsWindow[entry]["Close"].src       = "./Resources/closeon.png";
		dhlDetailsWindow[entry]["Close"].height    = 16;
		dhlDetailsWindow[entry]["Close"].width     = 16;
		dhlDetailsWindow[entry]["Close"].vOffset   = dhlDetailsWindow[entry]["Container"].height - 20;
		dhlDetailsWindow[entry]["Close"].hOffset   = dhlDetailsWindow[entry]["Container"].width - 20;
		dhlDetailsWindow[entry]["Close"].tooltip   = "Close this window";
		dhlDetailsWindow[entry]["Close"].onMouseDown = function(){
			dhlDetailsWindow[entry]["Close"].src       = "./Resources/close.png";}
		dhlDetailsWindow[entry]["Close"].onMouseUp = function(){
			dhlDetailsWindow[entry]["Close"].src       = "./Resources/closeon.png";
			dhlDetailsWindow[entry]["Container"].visible = 0;}
		
	}
	
	function dhlTrack(tNumber, entry, automatic){
		if (automatic != 1){pleaseWait();}
		url = new URL();
		url.location = "http://track.dhl-usa.com/TrackRslts.asp";
		url.postData = "txtTrackNbrs="+tNumber.replace(/ /g, "")+"&hdnErrorMsg=&hdnTrackMode=nbr&hdnPostType=init&hdnRefPage=0";
		url.entry = entry;
		url.tNumber = tNumber;
		url.automatic = automatic;
		url.fetchAsync(dhlProcessResults);

	}
	
	function dhlProcessResults( url ){
		if (url.response == 200){
		results = url.result;
		if (results.match(/<input type="hidden" name="hdnOkTotal" value="(\S.*)"\/>/)[1] != 1){
			displayedNumbers[url.entry].status = "Invalid Number";
			displayedNumbers[url.entry].readout.status.src = "./Resources/exclaimation.png";
			displayedNumbers[url.entry].readout.status.tooltip = "Invalid Number";

		} else {
			
			results = results.replace(/\n*/g, "");
			results = results.replace(/\r*/g, "");
			results = results.replace(/\t*/g, "");
			xmlResults = results.match(/<input type="hidden" name="hdnXMLResponse_\d*" value="([^\"]+)"\/>/g).join("");
			xmlResults = xmlResults.replace(/<input type="hidden" name="hdnXMLResponse_\d*" value="/g, "");
			xmlResults = xmlResults.replace(/\"\/>/g, "");
			xmlResults = xmlResults.replace(/&gt;/g, ">");
			xmlResults = xmlResults.replace(/&lt;/g, "<");
			xmlResults = xmlResults.replace(/&quot;/g, "\"");
			
			xmlResults = xmlResults.match(/<TrackShipments>(.*)<\/TrackShipments>/)[1];
			
			info = new Array();
			if (xmlResults.match(/<Result>(.*)<\/Result>/)){
				info["Results"] = xmlResults.match(/<Result>(.*)<\/Result>/)[1];
				info["Results"] = info["Results"].match(/<Desc>(.*)<\/Desc>/)[1];}
								
			if (xmlResults.match(/<ShipmentType>(.*)<\/ShipmentType>/)){
				info["Type"] = xmlResults.match(/<ShipmentType>(.*)<\/ShipmentType>/)[1];
				displayedNumbers[url.entry].shipmentType = info["Type"].match(/<Desc>(.*)<\/Desc>/)[1];}
				
			if (xmlResults.match(/<Service>(.*)<\/Service>/)){ 
				info["Service"] = xmlResults.match(/<Service>(.*)<\/Service>/)[1];
				displayedNumbers[url.entry].serviceType = info["Service"].match(/<Desc>(.*)<\/Desc>/)[1];
				}
				
			if (xmlResults.match(/<Origin>(.*)<\/Origin>/)){ 
				info["Origin"] = xmlResults.match(/<Origin>(.*)<\/Origin>/)[1];
				displayedNumbers[url.entry].originCode = info["Origin"].match(/<Station>(.*)<\/Station>/)[1];}
				
			if (xmlResults.match(/<OriginDescr>(.*)<\/OriginDescr>/)){ 
				info["OriginDescr"] = xmlResults.match(/<OriginDescr>(.*)<\/OriginDescr>/)[1];
				displayedNumbers[url.entry].origin = info["OriginDescr"].match(/<Location><!\[CDATA\[(.*)\]\]><\/Location>/)[1];}
			
			if (xmlResults.match(/<Destination>(.*)<\/Destination>/)){ 
				info["Destination"] = xmlResults.match(/<Destination>(.*)<\/Destination>/)[1];
				displayedNumbers[url.entry].destinationCode = info["Destination"].match(/<Station>(.*)<\/Station>/)[1];}
				
			if (xmlResults.match(/<DestinationDescr>(.*)<\/DestinationDescr>/)){ 
				info["DestinationDescr"] = xmlResults.match(/<DestinationDescr>(.*)<\/DestinationDescr>/)[1];
				displayedNumbers[url.entry].destination = info["DestinationDescr"].match(/<Location><!\[CDATA\[(.*)\]\]><\/Location>/)[1];}
				
			if (xmlResults.match(/<Pieces>(.*)<\/Pieces>/)){ 
				displayedNumbers[url.entry].pieces = xmlResults.match(/<Pieces>(.*)<\/Pieces>/)[1];}
				
			if (xmlResults.match(/<Weight>(.*)<\/Weight>/)){ 
				displayedNumbers[url.entry].weight = xmlResults.match(/<Weight>(.*)<\/Weight>/)[1];}
				
			if (xmlResults.match(/<Receiver>(.*)<\/Receiver>/)){ 
				info["Receiver"] = xmlResults.match(/<Receiver>(.*)<\/Receiver>/)[1];
				destinationAddy = new Array();
				if (info["Receiver"].match(/<CompanyName><!\[CDATA\[(.*)\]\]><\/CompanyName>/)) {
					companyname = info["Receiver"].match(/<CompanyName><!\[CDATA\[(.*)\]\]><\/CompanyName>/)[1];
					destinationAddy.push(companyname);
					displayedNumbers[url.entry].receiver = companyname;}
									
				if (info["Receiver"].match(/<City><!\[CDATA\[(.*)\]\]><\/City>/)) {
					city = info["Receiver"].match(/<City><!\[CDATA\[(.*)\]\]><\/City>/)[1];
					destinationAddy.push(city);}
					
				if (info["Receiver"].match(/<State>(.*)<\/State>/)){
					state = info["Receiver"].match(/<State>(.*)<\/State>/)[1];
					destinationAddy.push(state);}
					
				if (info["Receiver"].match(/<PostalCode>(.*)<\/PostalCode>/)){
					postalcode = info["Receiver"].match(/<PostalCode>(.*)<\/PostalCode>/)[1];
					destinationAddy.push(postalcode);}
					
				
				displayedNumbers[url.entry].destinationAddy = destinationAddy.join(", ");
				}
				
			if (xmlResults.match(/<Sender>(.*)<\/Sender>/)){ 
				info["Sender"] = xmlResults.match(/<Sender>(.*)<\/Sender>/)[1];
				senderAddy = new Array();
				if (info["Sender"].match(/<CompanyName><!\[CDATA\[(.*)\]\]><\/CompanyName>/)) {
					companyname = info["Sender"].match(/<CompanyName><!\[CDATA\[(.*)\]\]><\/CompanyName>/)[1];
					senderAddy.push(companyname);
					displayedNumbers[url.entry].sender = companyname;}
									
				if (info["Sender"].match(/<City><!\[CDATA\[(.*)\]\]><\/City>/)) {
					city = info["Sender"].match(/<City><!\[CDATA\[(.*)\]\]><\/City>/)[1];
					senderAddy.push(city);}
					
				if (info["Sender"].match(/<State>(.*)<\/State>/)){
					state = info["Sender"].match(/<State>(.*)<\/State>/)[1];
					senderAddy.push(state);}
					
				if (info["Sender"].match(/<PostalCode>(.*)<\/PostalCode>/)){
					postalcode = info["Sender"].match(/<PostalCode>(.*)<\/PostalCode>/)[1];
					senderAddy.push(postalcode);}
					
				
				displayedNumbers[url.entry].senderAddy = senderAddy.join(", ");
				}				
			
			if (xmlResults.match(/<ShipperReference><!\[CDATA\[(.*)\]\]><\/ShipperReference>/)) {
				displayedNumbers[url.entry].reference = xmlResults.match(/<ShipperReference><!\[CDATA\[(.*)\]\]><\/ShipperReference>/)[1];
				}
				
			if (xmlResults.match(/<Pickup>(.*)<\/Pickup>/)){ 
				info["Pickup"] = xmlResults.match(/<Pickup>(.*)<\/Pickup>/)[1];
				date = info["Pickup"].match(/<Date>(.*)<\/Date>/)[1];
				time = info["Pickup"].match(/<Time>(.*)<\/Time>/)[1];
				if (info["Pickup"].match(/<Location>(.*)<\/Location>/)){					
					pickuplocation = info["Pickup"].match(/<Location>(.*)<\/Location>/)[1];
					displayedNumbers[url.entry].pickupLocation = pickuplocation.match(/<Desc>(.*)<\/Desc>/)[1];
				}
				
				displayedNumbers[url.entry].shipDate = date + ", " + time;}

			if (xmlResults.match(/<ShipmentAcknowledged>(.*)<\/ShipmentAcknowledged>/)){ 
				info["Pickup"] = xmlResults.match(/<ShipmentAcknowledged>(.*)<\/ShipmentAcknowledged>/)[1];
				date = info["Pickup"].match(/<Date>(.*)<\/Date>/)[1];
				displayedNumbers[url.entry].shipmentAck = date;}
			
			if (xmlResults.match(/<TenderedUSPS>(.*)<\/TenderedUSPS>/)){ 
				info["Pickup"] = xmlResults.match(/<TenderedUSPS>(.*)<\/TenderedUSPS>/)[1];
				date = info["Pickup"].match(/<Date>(.*)<\/Date>/)[1];
				time = info["Pickup"].match(/<Time>(.*)<\/Time>/)[1];
				
				displayedNumbers[url.entry].tenderedUSPS = date +", "+time;}
				
			if (xmlResults.match(/<Delivery>(.*)<\/Delivery>/)){ 
				info["Delivery"] = xmlResults.match(/<Delivery>(.*)<\/Delivery>/)[1];
				date = info["Delivery"].match(/<Date>(.*)<\/Date>/)[1];
				time = info["Delivery"].match(/<Time>(.*)<\/Time>/)[1];
				if (info["Delivery"].match(/<Location>(.*)<\/Location>/)){					
					Deliverylocation = info["Delivery"].match(/<Location>(.*)<\/Location>/)[1];
					displayedNumbers[url.entry].deliveredLoc = Deliverylocation.match(/<Desc>(.*)<\/Desc>/)[1];
				}
				if (info["Delivery"].match(/<Signatory><!\[CDATA\[(.*)\]\]><\/Signatory>/)){					
					displayedNumbers[url.entry].signedBy = info["Delivery"].match(/<Signatory><!\[CDATA\[(.*)\]\]><\/Signatory>/)[1];
				}				
				displayedNumbers[url.entry].shipDate = date + ", " + time;}
				
			if (xmlResults.match(/<DeliveryNotificationAllow>(.*)<\/DeliveryNotificationAllow>/)){ 
				displayedNumbers[url.entry].deliveryNotificationAllow = xmlResults.match(/<DeliveryNotificationAllow>(.*)<\/DeliveryNotificationAllow>/)[1];}

			if (xmlResults.match(/<EstDeliveryDate>(.*)<\/EstDeliveryDate>/)){ 
				displayedNumbers[url.entry].estDeliveryDate = xmlResults.match(/<EstDeliveryDate>(.*)<\/EstDeliveryDate>/)[1];}
				
			if (xmlResults.match(/<TrackingHistory>(.*)<\/TrackingHistory>/)){ 
				info["TrackingHistory"] = xmlResults.match(/<TrackingHistory>(.*)<\/TrackingHistory>/)[1];
				location = "";
				statusArray = info["TrackingHistory"].split("</Status>");
				currentStatus = statusArray[0];
				displayedNumbers[url.entry].status = currentStatus.match(/<StatusDesc id="\d*">(.*)<\/StatusDesc>/)[1];
				displayedNumbers[url.entry].lastUpdateDate = currentStatus.match(/<Date>(.*)<\/Date>/)[1];
				displayedNumbers[url.entry].lastUpdateTime = currentStatus.match(/<Time>(.*)<\/Time>/)[1];
				if (currentStatus.match(/<City>(.*)<\/City>/)){
					city = currentStatus.match(/<City>(.*)<\/City>/)[1];
					location = city;}
				if (currentStatus.match(/<State>(.*)<\/State>/)){
					state = currentStatus.match(/<State>(.*)<\/State>/)[1];
					location += ", "+state;}
				if (currentStatus.match(/<Country>(.*)<\/Country>/)){
					country = currentStatus.match(/<Country><!\[CDATA\[(.*)\]\]><\/Country>/)[1];
					location += ", "+ country;}
				displayedNumbers[url.entry].location = location;
			}
				
			if ((displayedNumbers[url.entry].status.match(/Transit/i))||
			    (displayedNumbers[url.entry].status.match(/Departing Origin/i)) ||
			    (displayedNumbers[url.entry].status.match(/Picked Up/i))||
			    (displayedNumbers[url.entry].status.match(/Departing origin/i))||
			    (displayedNumbers[url.entry].status.match(/Clearance processing complete/i))||
			    (displayedNumbers[url.entry].status.match(/Shipment Request Acknowledged/i))||
			    (displayedNumbers[url.entry].status.match(/Shipment arrived at incorrect facility. Sent to correct destination/i))||
			    (displayedNumbers[url.entry].status.match(/Arrived at \S* facility/i))){	
				displayedNumbers[url.entry].readout.status.src = "./Resources/truck.png";
				displayedNumbers[url.entry].readout.status.tooltip = "In Transit";
			}
		
			else if ((displayedNumbers[url.entry].status.match(/Delivered/i)) ||
				((displayedNumbers[url.entry].status.match(/Final Delivery Confirmed/i)))){
				displayedNumbers[url.entry].readout.status.src = "./Resources/box.png";
				displayedNumbers[url.entry].readout.status.tooltip = "Delivered";
			} else {
				displayedNumbers[url.entry].readout.status.src = "./Resources/exclaimation.png";
				displayedNumbers[url.entry].readout.status.tooltip = "Unknown Status Type";
			}
			
			if (url.automatic != 1){dhlDetails(url.entry);}			
			
		}
	
		} else {
			print(url.response);
			displayedNumbers[url.entry].readout.status.src = "./Resources/exclaimation.png";
			displayedNumbers[url.entry].readout.status.tooltip = "Error Retrieving Page";
		}
	displayedNumbers[url.entry].readout.status.reload();
	}

function dhlWebpage(tNumber){
		url = new URL();
		url.location = "http://track.dhl-usa.com/TrackRslts.asp";
		url.postData = "txtTrackNbrs="+tNumber.replace(/ /g, "")+"&hdnErrorMsg=&hdnTrackMode=nbr&hdnPostType=init&hdnRefPage=0";
		url.outputFile = "./DHLOutput.html";
		url.fetch();
		runCommand("open DHLOutput.html");
}
