	fedexDetailsWindow = new Array(); 
	function fedexDetails(entry){
		$_ = displayedNumbers[entry];
		
		fedexDetailsWindow[entry] = new Array();
		fedexDetailsWindow[entry]["Container"] = new Window("details"+entry);
		fedexDetailsWindow[entry]["Container"].height = 300;
		fedexDetailsWindow[entry]["Container"].width  = 300;
		fedexDetailsWindow[entry]["Container"].visible = 1;

		fedexDetailsWindow[entry]["BackgroundTop"] = new Image(fedexDetailsWindow[entry]["Container"]);
		fedexDetailsWindow[entry]["BackgroundTop"].width    = fedexDetailsWindow[entry]["Container"].width;
		fedexDetailsWindow[entry]["BackgroundTop"].height   = 10;
		fedexDetailsWindow[entry]["BackgroundTop"].src      = "./Resources/backgroundTop.png";
		fedexDetailsWindow[entry]["BackgroundTop"].colorize = preferences.bezelColor.value;

		fedexDetailsWindow[entry]["BackgroundCenter"] = new Image(fedexDetailsWindow[entry]["Container"]);
		fedexDetailsWindow[entry]["BackgroundCenter"].width    = fedexDetailsWindow[entry]["Container"].width;
		fedexDetailsWindow[entry]["BackgroundCenter"].height   = 280;
		fedexDetailsWindow[entry]["BackgroundCenter"].src      = "./Resources/backgroundCenter.png";
		fedexDetailsWindow[entry]["BackgroundCenter"].colorize = preferences.bezelColor.value;
		fedexDetailsWindow[entry]["BackgroundCenter"].vOffset  = fedexDetailsWindow[entry]["BackgroundTop"].vOffset + fedexDetailsWindow[entry]["BackgroundTop"].height;

		fedexDetailsWindow[entry]["BackgroundBottom"] = new Image(fedexDetailsWindow[entry]["Container"]);
		fedexDetailsWindow[entry]["BackgroundBottom"].width    = fedexDetailsWindow[entry]["Container"].width;
		fedexDetailsWindow[entry]["BackgroundBottom"].height   = 10;
		fedexDetailsWindow[entry]["BackgroundBottom"].src      = "./Resources/backgroundBottom.png";
		fedexDetailsWindow[entry]["BackgroundBottom"].colorize = preferences.bezelColor.value;	
		fedexDetailsWindow[entry]["BackgroundBottom"].vOffset  = fedexDetailsWindow[entry]["BackgroundCenter"].vOffset + fedexDetailsWindow[entry]["BackgroundCenter"].height;

		fedexDetailsWindow[entry]["Details"] = new TextArea(fedexDetailsWindow[entry]["Container"]);
		dataStr = "";
		for (items in displayedNumbers[entry]){
		$_ = displayedNumbers[entry][items];
			if (($_ != "Unavailable")
			  &&(items != "itemFrame")
			  &&(items != "position")
			  &&(items != "readout"))
			{
				dataStr += resolveNumValue(items) +": "+$_+"\n";
			}
		}
		fedexDetailsWindow[entry]["Details"].data    = dataStr;
		fedexDetailsWindow[entry]["Details"].font    = "Verdana";
		fedexDetailsWindow[entry]["Details"].color   = preferences.fontColor.value;
		fedexDetailsWindow[entry]["Details"].size    = 12;
		fedexDetailsWindow[entry]["Details"].hOffset = 10;
		fedexDetailsWindow[entry]["Details"].vOffset = 10;
		fedexDetailsWindow[entry]["Details"].width   = 286;
		fedexDetailsWindow[entry]["Details"].height  = 270;
		fedexDetailsWindow[entry]["Details"].editable = 0;
		if (dataStr.split("\n").length > 18){
			fedexDetailsWindow[entry]["Details"].scrollbar = "";
			fedexDetailsWindow[entry]["Details"].scrollbar = 1;		
		} else{
			fedexDetailsWindow[entry]["Details"].scrollbar = "";
			fedexDetailsWindow[entry]["Details"].scrollbar = 0;
		}


		fedexDetailsWindow[entry]["Close"] = new Image(fedexDetailsWindow[entry]["Container"]);
		fedexDetailsWindow[entry]["Close"].src       = "./Resources/closeon.png";
		fedexDetailsWindow[entry]["Close"].height    = 16;
		fedexDetailsWindow[entry]["Close"].width     = 16;
		fedexDetailsWindow[entry]["Close"].vOffset   = fedexDetailsWindow[entry]["Container"].height - 20;
		fedexDetailsWindow[entry]["Close"].hOffset   = fedexDetailsWindow[entry]["Container"].width - 20;
		fedexDetailsWindow[entry]["Close"].tooltip   = "Close this window";
		fedexDetailsWindow[entry]["Close"].onMouseDown = function(){
			fedexDetailsWindow[entry]["Close"].src       = "./Resources/close.png";}
		fedexDetailsWindow[entry]["Close"].onMouseUp = function(){
			fedexDetailsWindow[entry]["Close"].src       = "./Resources/closeon.png";
			fedexDetailsWindow[entry]["Container"].visible = 0;}
		
	}

	function fedexTrack(tNumber, entry, automatic){
		if (automatic != 1){pleaseWait();}
		url = new URL();
		url.location = "http://www.fedex.com/Tracking/Detail?template_type=print&trackNum="+tNumber;
		url.entry = entry;
		url.tNumber = tNumber;
		url.automatic = automatic;
		url.fetchAsync(fedexProcessResults);

	}
	
	function fedexProcessResults( url ){
		if (url.response == 200){
		results = url.result;
		if (results.match(/Invalid/i)){
			displayedNumbers[url.entry].status = "Invalid Number";
			displayedNumbers[url.entry].readout.status.src = "./Resources/exclaimation.png";
			displayedNumbers[url.entry].readout.status.tooltip = "Invalid Number";

		}else if ((results.match("Not Found")) ||
			  (results.match("Not tracked"))){
						
			displayedNumbers[url.entry].status = "Number Not Found";
			displayedNumbers[url.entry].readout.status.src = "./Resources/exclaimation.png";
			displayedNumbers[url.entry].readout.status.tooltip = "Number Not Found";
		
		} else {
			results = results.split("<!-- shipment info -->");
			results = results[1].split("<!-- END Scan Activity -->");
			results = results[0].split("<!-- BEGIN Scan Activity -->");

			details = results[0].split("<TR");
			
			for (items in details){
				if (details[items].match("Ship date")){
					shipDate = details[items];
					shipDateArray = shipDate.split("<TD");
					shipDate = shipDateArray[3].match(/>([^<]+)</i)[1];
					shipDate = shipDate.match(/\S.*\S/)[0];
					displayedNumbers[url.entry].shipDate = shipDate;//
				} else if (details[items].match("Estimated delivery")){
					estDate = details[items];
					estDateArray = estDate.split("<TD");
					estDate = estDateArray[3].match(/>([^<]+)</i)[1];
					estDate = estDate.match(/\S.*\S/)[0];
					displayedNumbers[url.entry].estDeliveryDate = estDate;//
				} else if (details[items].match("Reference")){
					estDate = details[items];
					estDateArray = estDate.split("<TD");
					estDate = estDateArray[3].match(/>([^<]+)</i)[1];
					estDate = estDate.match(/\S.*\S/)[0];
					displayedNumbers[url.entry].reference = estDate;//
				} else if (details[items].match("Purchase order number")){
					estDate = details[items];
					estDateArray = estDate.split("<TD");
					estDate = estDateArray[3].match(/>([^<]+)</i)[1];
					estDate = estDate.match(/\S.*\S/)[0];
					displayedNumbers[url.entry].poNumber = estDate;//
				}  else if (details[items].match("Invoice number")){
					estDate = details[items];
					estDateArray = estDate.split("<TD");
					estDate = estDateArray[3].match(/>([^<]+)</i)[1];
					estDate = estDate.match(/\S.*\S/)[0];
					displayedNumbers[url.entry].invoiceNumber = estDate;//
				} else if (details[items].match("Department number")){
					estDate = details[items];
					estDateArray = estDate.split("<TD");
					estDate = estDateArray[3].match(/>([^<]+)</i)[1];
					estDate = estDate.match(/\S.*\S/)[0];
					displayedNumbers[url.entry].deptNumber = estDate;//
				}
				
				
				else if (details[items].match("Delivery date")){
					deliveryDate = details[items];
					deliveryDateArray = deliveryDate.split("<TD");
					deliveryDate = deliveryDateArray[3].match(/>([^<]+)</i)[1];
					deliveryDate = deliveryDate.match(/\S.*\S/)[0];
					displayedNumbers[url.entry].deliveryDate = deliveryDate;//					
				}
				else if (details[items].match("Pieces")){
					pieces = details[items];
					piecesArray = pieces.split("<TD");
					pieces = piecesArray[3].match(/>([^<]+)</i)[1];
					displayedNumbers[url.entry].pieces = pieces;//
				}
				else if (details[items].match("Destination")){
					destination = details[items];
					destinationArray = destination.split("<TD>");
					destination = destinationArray[3];
					destination = destinationArray[3].replace("</TD>", "");	
					destination = destination.match(/\S.*\S/)[0];
					displayedNumbers[url.entry].destination = destination;//					
				}
				else if (details[items].match("Weight")){
					weight = details[items];
					weightArray = weight.split("<TD>");
					weight = weightArray[3];
					weight = weightArray[3].replace("</TD>", "");	
					weight = weight.match(/\S.*\S/)[0];
					displayedNumbers[url.entry].weight = weight;//					
				}
				else if (details[items].match("Status")){
					status = details[items];
					statusArray = status.split("<TD>");
					status = statusArray[3];
					status = statusArray[3].replace("</TD>", "");	
					status = status.match(/\S.*\S/)[0];
					displayedNumbers[url.entry].status = status;//
				}

			}
			

			scanDetailsArray = results[1].split("<tr");	
			scanDetailsArray = scanDetailsArray[3].split("<td");
			scanDate = scanDetailsArray[2];
			scanTime = scanDetailsArray[3];
			scanActivity = scanDetailsArray[7];
			scanLocation = scanDetailsArray[11];
			scanDetails = scanDetailsArray[15];

			scanActivityArray = scanActivity.split("<B>");
			scanActivityArray = scanActivityArray[1].split("</B>");
			scanActivity = scanActivityArray[0];
			scanActivity = scanActivity.match(/\S.*\S/);

			scanDate = scanDate.match(/<B>([^<]+)<\/B>/i)[1];
			scanTime = scanTime.match(/>([^<]+)</i)[1];
			if(scanTime.match("&nbsp;")){scanTime = scanTime.replace("&nbsp;", "");}
			scanLocation = scanLocation.match(/>([^<]+)</i)[1];
			if(scanLocation.match("&nbsp;")){scanLocation = scanLocation.replace("&nbsp;", "");}

			scanDetails = scanDetails.match(/>([^<]+)</i)[1];
			scanDetails = scanDetails.match(/\S.*\S/)[0];
			if(scanDetails.match("&nbsp;")){scanDetails = scanDetails.replace("&nbsp;", "");}
			
			//cleanup unnecessary arrays
			delete shipDateArray;
			delete deliveryDateArray;
			delete destinationArray;
			delete piecesArray;
			delete weightArray;
			delete statusArray;
			delete scanDetailsArray;
			delete scanActivityArray;


			if (scanLocation){displayedNumbers[url.entry].location = scanLocation;}
			if (scanDate){displayedNumbers[url.entry].lastUpdateDate = scanDate;}
			if (scanTime){displayedNumbers[url.entry].lastUpdateTime = scanTime;}
			if (scanActivity){displayedNumbers[url.entry].activity = scanActivity;}
			if (scanDetails){displayedNumbers[url.entry].details = scanDetails;}

			displayedNumbers[url.entry].readout.status.src = "./Resources/truck.png";
			displayedNumbers[url.entry].readout.status.tooltip = "In Transit";
			
			if (displayedNumbers[url.entry].status == "Delivered"){
				displayedNumbers[url.entry].readout.status.src = "./Resources/box.png";
				displayedNumbers[url.entry].readout.status.tooltip = "Delivered";
			}
			if (url.automatic != 1){fedexDetails(url.entry);}
		}
		} else {
			print(url.response);
			displayedNumbers[url.entry].readout.status.src = "./Resources/exclaimation.png";
			displayedNumbers[url.entry].readout.status.tooltip = "Error Retrieving Page";
		}
		displayedNumbers[url.entry].readout.status.reload();
	}
	
function fedexWebpage(tNumber){
	openURL("http://www.fedex.com/Tracking/Detail?template_type=print&trackNum="+tNumber);
}