
function createConsole(){
	
	defaultShadow = new Shadow();
	defaultShadow.hOffset = 2;
	defaultShadow.vOffset = 2;
	defaultShadow.opacity = 200;
	defaultShadow.color = "#000000";
	
//	mainWindow = new Window(); //built as first window in xml to get around mac bug
	mainWindow.visible = 0;	
	mainWindow.width = 300;
	mainWindow.height = 23;
	mainWindow.level = preferences.konfabulatorWindowLevel.value;
	mainWindow.locked = preferences.konfabulatorLockWindowPosition.value;
	mainWindow.opacity = preferences.konfabulatorWindowOpacity.value;
	
	mainWindow.MenuItems = new Array();
		addAboutMenuItem(mainWindow.MenuItems);
		addDonateMenuItem(mainWindow.MenuItems);
		addLicenseMenuItem(mainWindow.MenuItems);
		addReportBugMenuItem(mainWindow.MenuItems);
	mainWindow.contextMenuItems = mainWindow.MenuItems;
	
	mainWindow.topBar = new Image(mainWindow);
	mainWindow.topBar.src = "./Resources/backgroundTop.png";
	mainWindow.topBar.width = mainWindow.width;
	mainWindow.topBar.height = 11;
	mainWindow.topBar.visible = 1;
	mainWindow.topBar.hOffset = 0;
	mainWindow.topBar.vOffset = 0;
	mainWindow.topBar.colorize = preferences.bezelColor.value;
	mainWindow.topBar.zOrder = 2;
	
	mainWindow.midBar = new Image(mainWindow);
	mainWindow.midBar.src = "./Resources/backgroundCenter.png";
	mainWindow.midBar.width = mainWindow.width;
	mainWindow.midBar.height = 1;
	mainWindow.midBar.visible = 1;
	mainWindow.midBar.hOffset = 0;
	mainWindow.midBar.vOffset = 11;	
	mainWindow.midBar.colorize = preferences.bezelColor.value;
	mainWindow.midBar.zOrder = 0;
	
	
	mainWindow.botBar = new Image(mainWindow);
	mainWindow.botBar.src = "./Resources/backgroundBottom.png";
	mainWindow.botBar.width = mainWindow.width;
	mainWindow.botBar.height = 11;
	mainWindow.botBar.visible = 1;
	mainWindow.botBar.hOffset = 0;
	mainWindow.botBar.vOffset = 12;
	mainWindow.botBar.colorize = preferences.bezelColor.value;
	mainWindow.botBar.zOrder = 2;
	mainWindow.botBar.mouseMoveAction = function(){
		
		newHeight = (mainWindow.vOffset - system.event.screenY)*-1;
		if(newHeight >= 75){
			mainWindow.height = newHeight;
			mainWindow.botBar.vOffset = newHeight - 11;
			mainWindow.midBar.height = newHeight - 22;
			mainWindow.contentFrame.height = preferences.expandedHeight.value - 40;
			mainWindow.frameBg.height = mainWindow.contentFrame.height;
			mainWindow.scrollbar.height = mainWindow.contentFrame.height;
						
			preferences.expandedHeight.value = mainWindow.height;
			savePreferences();
		}
	}
		
	
	mainWindow.titleBar = new Text(mainWindow);
	mainWindow.titleBar.data = "Universal Shipment Tracker";
	mainWindow.titleBar.zOrder = 3;
	mainWindow.titleBar.font = "Verdana";
	mainWindow.titleBar.size = 16;
	mainWindow.titleBar.color = "#FFFFFF";
	mainWindow.titleBar.hOffset = 10;
	mainWindow.titleBar.vOffset = mainWindow.titleBar.size + 2;
	mainWindow.titleBar.visible = 1;
	mainWindow.titleBar.shadow = defaultShadow;
	
	mainWindow.collapseButton = new Image(mainWindow);
	mainWindow.collapseButton.src = "./Resources/dropdownbg.png";
	mainWindow.collapseButton.width = 16;
	mainWindow.collapseButton.height = 16;
	mainWindow.collapseButton.vOffset = 5;
	mainWindow.collapseButton.hOffset = 275;
	mainWindow.collapseButton.visible = 1;
	mainWindow.collapseButton.colorize = preferences.bezelColor.value;
	mainWindow.collapseButton.tooltip = "Hide/Show shipments";
	
	mainWindow.collapseButton.arrow = new Image(mainWindow);
	mainWindow.collapseButton.arrow.src = "./Resources/dropdown.png";
	mainWindow.collapseButton.arrow.width = 15;
	mainWindow.collapseButton.arrow.height = 15;
	mainWindow.collapseButton.arrow.vRegistrationPoint = 8;
	mainWindow.collapseButton.arrow.hRegistrationPoint = 8;
	mainWindow.collapseButton.arrow.tracking = "rectangle";
	mainWindow.collapseButton.arrow.vOffset = 12;
	mainWindow.collapseButton.arrow.hOffset = 283;
	mainWindow.collapseButton.arrow.visible = 1;
	mainWindow.collapseButton.arrow.rotation = -90;
	mainWindow.collapseButton.arrow.collapsed = new Boolean(1);
	mainWindow.collapseButton.arrow.tooltip = "Hide/Show shipments";
	mainWindow.collapseButton.arrow.onMouseUp = function(){
		
		
		animations = new Array();
		if (this.collapsed == 1){
			rotation = 0;
			opacity = 255;
			mainWindow.botBar.onMouseMove = mainWindow.botBar.mouseMoveAction;
			mainWindow.botBar.src = "./Resources/backgroundBottomGrabbie.png";
		} else {
			rotation = -90;
			opacity = 0;
			mainWindow.botBar.onMouseMove = "";
			mainWindow.botBar.src = "./Resources/backgroundBottom.png";
		}
		collapse(this.collapsed);
		
		a = new RotateAnimation(mainWindow.collapseButton.arrow, rotation, 1000, animator.kEaseInOut);
		animations.push(a); 
		
		animator.runUntilDone(animations);
			
		this.collapsed = ! this.collapsed;
		
		
	}
	

	mainWindow.addButton = new Image(mainWindow);
	mainWindow.addButton.src = "./Resources/dropdownbg.png";
	mainWindow.addButton.width = 16;
	mainWindow.addButton.height = 16;
	mainWindow.addButton.vOffset = 5;
	mainWindow.addButton.hOffset = 255;
	mainWindow.addButton.visible = 1;
	mainWindow.addButton.colorize = preferences.bezelColor.value;
	mainWindow.addButton.tooltip = "Add a shipment";
	
	mainWindow.addButton.add = new Text(mainWindow);
	mainWindow.addButton.add.data = "+";
	mainWindow.addButton.add.shadow = defaultShadow;
	mainWindow.addButton.add.size = 18;
	mainWindow.addButton.add.height = 16
	mainWindow.addButton.add.width = 16;
	mainWindow.addButton.add.bgColor = "#FF0000";
	mainWindow.addButton.add.bgOpacity = 0;
	mainWindow.addButton.add.vOffset = mainWindow.addButton.add.size + 2;
	mainWindow.addButton.add.hOffset = 257;
	mainWindow.addButton.add.tracking = "rectangle";
	mainWindow.addButton.add.color = "#FFFFFF";
	mainWindow.addButton.add.visible = 1;
	mainWindow.addButton.add.tooltip = "Add a shipment";
	mainWindow.addButton.add.onMouseUp = function(){addTrackingNumber(0,0);}
		

	mainWindow.contentFrame = new Frame(mainWindow);
	mainWindow.contentFrame.width = 264;
	mainWindow.contentFrame.height = preferences.expandedHeight.value - 40;
	mainWindow.contentFrame.vOffset = 25;
	mainWindow.contentFrame.hOffset = 10;
	mainWindow.contentFrame.visible = 1;
	mainWindow.contentFrame.zOrder = 1;

	mainWindow.scrollbar = new ScrollBar(mainWindow);
	mainWindow.scrollbar.autoHide = 0;
	mainWindow.scrollbar.height = mainWindow.contentFrame.height;
	mainWindow.scrollbar.hOffset = mainWindow.contentFrame.hOffset + mainWindow.contentFrame.width;
	mainWindow.scrollbar.vOffset = mainWindow.contentFrame.vOffset;
	mainWindow.scrollbar.zOrder = 2;
	mainWindow.scrollbar.visible = 1;
	
	mainWindow.contentFrame.vScrollBar = mainWindow.scrollbar;
		
	mainWindow.frameBg = new TextArea(mainWindow);
	mainWindow.frameBg.width = mainWindow.contentFrame.width;
	mainWindow.frameBg.height = mainWindow.contentFrame.height;
	mainWindow.frameBg.bgColor = "#000000";
	mainWindow.frameBg.bgOpacity = 255;
	mainWindow.frameBg.zOrder = 0;
	mainWindow.frameBg.vOffset = mainWindow.contentFrame.vOffset;
	mainWindow.frameBg.hOffset = mainWindow.contentFrame.hOffset;
	mainWindow.frameBg.editable =0;
	mainWindow.frameBg.scrollbar = 0;
	mainWindow.frameBg.visible = 1;

	mainWindow.legendFrame = new Frame(mainWindow);
	mainWindow.legendFrame.height = 22;
	mainWindow.legendFrame.width = mainWindow.contentFrame.width;
	mainWindow.legendFrame.vOffset = 0;
	mainWindow.legendFrame.hOffset = 0;
	mainWindow.legendFrame.parent = mainWindow;
	mainWindow.contentFrame.addSubview(mainWindow.legendFrame);
	
	mainWindow.legendFrame.helpButton = new Image();
	mainWindow.legendFrame.helpButton.src = "./Resources/qmark.png";
	mainWindow.legendFrame.helpButton.colorize = "#880088";
	mainWindow.legendFrame.helpButton.width = 16;
	mainWindow.legendFrame.helpButton.height = 16;
	mainWindow.legendFrame.helpButton.hOffset = mainWindow.legendFrame.width - 16;
	mainWindow.legendFrame.helpButton.vOffset = 3;
	mainWindow.legendFrame.helpButton.parent = mainWindow.legendFrame;
	mainWindow.legendFrame.helpButton.onMouseUp = function(){
		runCommand('open help.html');
	}
	mainWindow.legendFrame.addSubview(mainWindow.legendFrame.helpButton);
	
	mainWindow.legendFrame.trackAllButton = new Image();
	mainWindow.legendFrame.trackAllButton.src = "./Resources/trackAll.png";
	mainWindow.legendFrame.trackAllButton.tooltip = "Track All Shipments";
	mainWindow.legendFrame.trackAllButton.width = 35;
	mainWindow.legendFrame.trackAllButton.height = 16;
	mainWindow.legendFrame.trackAllButton.hOffset = 0;
	mainWindow.legendFrame.trackAllButton.vOffset = 3;
	mainWindow.legendFrame.trackAllButton.parent = mainWindow.legendFrame;
	mainWindow.legendFrame.trackAllButton.onMouseUp = function(){
		updateTimeronTimerFired();
	}
	mainWindow.legendFrame.addSubview(mainWindow.legendFrame.trackAllButton);

	mainWindow.legendFrame.hideUPS = new Image();
	if (preferences.hideups.value == 0){
		mainWindow.legendFrame.hideUPS.src = "./Resources/carrierShown.png";}
	else {
		mainWindow.legendFrame.hideUPS.src = "./Resources/carrierHidden.png";}
	mainWindow.legendFrame.hideUPS.height = 16;
	mainWindow.legendFrame.hideUPS.width = 16;
	mainWindow.legendFrame.hideUPS.vOffset = 3;
	mainWindow.legendFrame.hideUPS.hOffset = 40;
	mainWindow.legendFrame.hideUPS.shown = new Boolean(0);
	mainWindow.legendFrame.hideUPS.colorize = "#8A8446";
	mainWindow.legendFrame.hideUPS.carrier = "ups";
	mainWindow.legendFrame.hideUPS.carrierString = "UPS";
	mainWindow.legendFrame.hideUPS.onMouseUp = function(){
		if (system.event.modifiers == ""){
			hideCarrier(this.carrier, 0);
			eval("mainWindow.legendFrame.hide"+this.carrierString+".shown = ! mainWindow.legendFrame.hide"+this.carrierString+".shown");
		} else
		if (system.event.modifiers == "option"){

			if (hiddenCarriers[this.carrier] == 1){
				hideCarrier(this.carrier, 1);
			}
			
			for (i in hiddenCarriers){
				if((hiddenCarriers[i] != 1)
				&& (i != this.carrier)){
					hideCarrier(i, 1);
					
				}
			}
			resumeUpdates();
			animator.start(animations);

			

		
		} else 
		if (system.event.modifiers == "shift"){
			;
			if (hiddenCarriers[this.carrier] == 0){
				hideCarrier(this.carrier, 1);
			}
			for (i in hiddenCarriers){
				if((hiddenCarriers[i] == 1)
				&& (i != this.carrier)){
					hideCarrier(i, 1);
					
				}
				
			}
			resumeUpdates();
			animator.start(animations);
		}

		for (i in hiddenCarriers){
			if (eval("preferences.hide"+i+".value == 0")){
				eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".src = \"./Resources/carrierShown.png\"");
				eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".tooltip = carrierStrings[i]+\" Visible\\nClick to hide \"+carrierStrings[i]+\" Shipments\"");
			} else {
				eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".src = \"./Resources/carrierHidden.png\"");
				eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".tooltip = carrierStrings[i]+\" Hidden\\nClick to show \"+carrierStrings[i]+\" Shipments\"");
			}
		}

	}
	mainWindow.legendFrame.addSubview(mainWindow.legendFrame.hideUPS);


	mainWindow.legendFrame.hideFedEx = new Image();
	if (preferences.hidefedex.value == 0){
		mainWindow.legendFrame.hideFedEx.src = "./Resources/carrierShown.png";}
	else {
		mainWindow.legendFrame.hideFedEx.src = "./Resources/carrierHidden.png";}
	mainWindow.legendFrame.hideFedEx.height = 16;
	mainWindow.legendFrame.hideFedEx.width = 16;
	mainWindow.legendFrame.hideFedEx.vOffset = 3;
	mainWindow.legendFrame.hideFedEx.hOffset = 60;
	mainWindow.legendFrame.hideFedEx.shown = new Boolean(0);
	mainWindow.legendFrame.hideFedEx.colorize = "#0000AA";
	mainWindow.legendFrame.hideFedEx.carrier = "fedex";
	mainWindow.legendFrame.hideFedEx.carrierString = "FedEx";
	mainWindow.legendFrame.hideFedEx.onMouseUp = function(){
		if (system.event.modifiers == ""){
			hideCarrier(this.carrier, 0);
			eval("mainWindow.legendFrame.hide"+this.carrierString+".shown = ! mainWindow.legendFrame.hide"+this.carrierString+".shown");
		} else
		if (system.event.modifiers == "option"){

			if (hiddenCarriers[this.carrier] == 1){
				hideCarrier(this.carrier, 1);
			}
			
			for (i in hiddenCarriers){
				if((hiddenCarriers[i] != 1)
				&& (i != this.carrier)){
					hideCarrier(i, 1);
					
				}
			}
			resumeUpdates();
			animator.start(animations);

			

		
		} else 
		if (system.event.modifiers == "shift"){
			;
			if (hiddenCarriers[this.carrier] == 0){
				hideCarrier(this.carrier, 1);
			}
			for (i in hiddenCarriers){
				if((hiddenCarriers[i] == 1)
				&& (i != this.carrier)){
					hideCarrier(i, 1);
					
				}
				
			}
			resumeUpdates();
			animator.start(animations);
		}

		for (i in hiddenCarriers){
			if (eval("preferences.hide"+i+".value == 0")){
				eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".src = \"./Resources/carrierShown.png\"");
				eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".tooltip = carrierStrings[i]+\" Visible\\nClick to hide \"+carrierStrings[i]+\" Shipments\"");
			} else {
				eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".src = \"./Resources/carrierHidden.png\"");
				eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".tooltip = carrierStrings[i]+\" Hidden\\nClick to show \"+carrierStrings[i]+\" Shipments\"");
			}
		}
	}
	mainWindow.legendFrame.addSubview(mainWindow.legendFrame.hideFedEx);

	mainWindow.legendFrame.hideDHL = new Image();
	if (preferences.hidedhl.value == 0){
		mainWindow.legendFrame.hideDHL.src = "./Resources/carrierShown.png";
		mainWindow.legendFrame.hideDHL.tooltip = "FedEx Visible\nClick to hide FedEx Shipments";}
	else {
		mainWindow.legendFrame.hideDHL.src = "./Resources/carrierHidden.png";
		mainWindow.legendFrame.hideDHL.tooltip = "FedEx Hidden\nClick to show FedEx Shipments";}

	mainWindow.legendFrame.hideDHL.height = 16;
	mainWindow.legendFrame.hideDHL.width = 16;
	mainWindow.legendFrame.hideDHL.vOffset = 3;
	mainWindow.legendFrame.hideDHL.hOffset = 80;
	mainWindow.legendFrame.hideDHL.shown = new Boolean(0);
	mainWindow.legendFrame.hideDHL.colorize = "#AAAA00";
	mainWindow.legendFrame.hideDHL.carrier = "dhl";
	mainWindow.legendFrame.hideDHL.carrierString = "DHL";
	mainWindow.legendFrame.hideDHL.onMouseUp = function(){
		if (system.event.modifiers == ""){
			hideCarrier(this.carrier, 0);
			eval("mainWindow.legendFrame.hide"+this.carrierString+".shown = ! mainWindow.legendFrame.hide"+this.carrierString+".shown");
		} else
		if (system.event.modifiers == "option"){

			if (hiddenCarriers[this.carrier] == 1){
				hideCarrier(this.carrier, 1);
			}
			
			for (i in hiddenCarriers){
				if((hiddenCarriers[i] != 1)
				&& (i != this.carrier)){
					hideCarrier(i, 1);
					
				}
			}
			resumeUpdates();
			animator.start(animations);

			

		
		} else 
		if (system.event.modifiers == "shift"){
			;
			if (hiddenCarriers[this.carrier] == 0){
				hideCarrier(this.carrier, 1);
			}
			for (i in hiddenCarriers){
				if((hiddenCarriers[i] == 1)
				&& (i != this.carrier)){
					hideCarrier(i, 1);
					
				}
				
			}
			resumeUpdates();
			animator.start(animations);
		}

		for (i in hiddenCarriers){
			if (eval("preferences.hide"+i+".value == 0")){
				eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".src = \"./Resources/carrierShown.png\"");
				eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".tooltip = carrierStrings[i]+\" Visible\\nClick to hide \"+carrierStrings[i]+\" Shipments\"");
			} else {
				eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".src = \"./Resources/carrierHidden.png\"");
				eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".tooltip = carrierStrings[i]+\" Hidden\\nClick to show \"+carrierStrings[i]+\" Shipments\"");
			}
		}
	}

	mainWindow.legendFrame.addSubview(mainWindow.legendFrame.hideDHL);

	mainWindow.legendFrame.hideUSPS = new Image();
	if (preferences.hideusps.value == 0){
		mainWindow.legendFrame.hideUSPS.src = "./Resources/carrierShown.png";}
	else {
		mainWindow.legendFrame.hideUSPS.src = "./Resources/carrierHidden.png";}

	mainWindow.legendFrame.hideUSPS.height = 16;
	mainWindow.legendFrame.hideUSPS.width = 16;
	mainWindow.legendFrame.hideUSPS.vOffset = 3;
	mainWindow.legendFrame.hideUSPS.hOffset = 100;
	mainWindow.legendFrame.hideUSPS.shown = new Boolean(0);
	mainWindow.legendFrame.hideUSPS.colorize = "#AA0000";
	mainWindow.legendFrame.hideUSPS.carrier = "usps";
	mainWindow.legendFrame.hideUSPS.carrierString = "USPS";
	mainWindow.legendFrame.hideUSPS.onMouseUp = function(){
		if (system.event.modifiers == ""){
			hideCarrier(this.carrier, 0);
			eval("mainWindow.legendFrame.hide"+this.carrierString+".shown = ! mainWindow.legendFrame.hide"+this.carrierString+".shown");
		} else
		if (system.event.modifiers == "option"){

			if (hiddenCarriers[this.carrier] == 1){
				hideCarrier(this.carrier, 1);
			}
			
			for (i in hiddenCarriers){
				if((hiddenCarriers[i] != 1)
				&& (i != this.carrier)){
					hideCarrier(i, 1);
					
				}
			}
			resumeUpdates();
			animator.start(animations);

			

		
		} else 
		if (system.event.modifiers == "shift"){
			;
			if (hiddenCarriers[this.carrier] == 0){
				hideCarrier(this.carrier, 1);
			}
			for (i in hiddenCarriers){
				if((hiddenCarriers[i] == 1)
				&& (i != this.carrier)){
					hideCarrier(i, 1);
					
				}
				
			}
			resumeUpdates();
			animator.start(animations);
		}

		for (i in hiddenCarriers){
			if (eval("preferences.hide"+i+".value == 0")){
				eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".src = \"./Resources/carrierShown.png\"");
				eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".tooltip = carrierStrings[i]+\" Visible\\nClick to hide \"+carrierStrings[i]+\" Shipments\"");
			} else {
				eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".src = \"./Resources/carrierHidden.png\"");
				eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".tooltip = carrierStrings[i]+\" Hidden\\nClick to show \"+carrierStrings[i]+\" Shipments\"");
			}
		}

	}
	mainWindow.legendFrame.addSubview(mainWindow.legendFrame.hideUSPS);

	mainWindow.legendFrame.hidePurolator = new Image();
	if (preferences.hidepuro.value == 0){
		mainWindow.legendFrame.hidePurolator.src = "./Resources/carrierShown.png";}
	else {
		mainWindow.legendFrame.hidePurolator.src = "./Resources/carrierHidden.png";}

	mainWindow.legendFrame.hidePurolator.height = 16;
	mainWindow.legendFrame.hidePurolator.width = 16;
	mainWindow.legendFrame.hidePurolator.vOffset = 3;
	mainWindow.legendFrame.hidePurolator.hOffset = 120;
	mainWindow.legendFrame.hidePurolator.shown = new Boolean(0);
	mainWindow.legendFrame.hidePurolator.colorize = "#AA00AA";
	mainWindow.legendFrame.hidePurolator.carrier = "puro";
	mainWindow.legendFrame.hidePurolator.carrierString = "Purolator";
	mainWindow.legendFrame.hidePurolator.onMouseUp = function(){
		if (system.event.modifiers == ""){
			hideCarrier(this.carrier, 0);
			eval("mainWindow.legendFrame.hide"+this.carrierString+".shown = ! mainWindow.legendFrame.hide"+this.carrierString+".shown");
		} else
		if (system.event.modifiers == "option"){

			if (hiddenCarriers[this.carrier] == 1){
				hideCarrier(this.carrier, 1);
			}
			
			for (i in hiddenCarriers){
				if((hiddenCarriers[i] != 1)
				&& (i != this.carrier)){
					hideCarrier(i, 1);
					
				}
			}
			resumeUpdates();
			animator.start(animations);

			

		
		} else 
		if (system.event.modifiers == "shift"){
			;
			if (hiddenCarriers[this.carrier] == 0){
				hideCarrier(this.carrier, 1);
			}
			for (i in hiddenCarriers){
				if((hiddenCarriers[i] == 1)
				&& (i != this.carrier)){
					hideCarrier(i, 1);
					
				}
				
			}
			resumeUpdates();
			animator.start(animations);
		}

		for (i in hiddenCarriers){
			if (eval("preferences.hide"+i+".value == 0")){
				eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".src = \"./Resources/carrierShown.png\"");
				eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".tooltip = carrierStrings[i]+\" Visible\\nClick to hide \"+carrierStrings[i]+\" Shipments\"");
			} else {
				eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".src = \"./Resources/carrierHidden.png\"");
				eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".tooltip = carrierStrings[i]+\" Hidden\\nClick to show \"+carrierStrings[i]+\" Shipments\"");
			}
		}

	}
	mainWindow.legendFrame.addSubview(mainWindow.legendFrame.hidePurolator);

	
	mainWindow.legendFrame.trackingArrow = new Image();
	mainWindow.legendFrame.trackingArrow.src = "./Resources/tracking.png";
	mainWindow.legendFrame.trackingArrow.parent = mainWindow.legendFrame;
	mainWindow.legendFrame.trackingArrow.height = 15;
	mainWindow.legendFrame.trackingArrow.width = 15;
	mainWindow.legendFrame.trackingArrow.vRegistrationPoint = 8;
	mainWindow.legendFrame.trackingArrow.hRegistrationPoint = 8;
	mainWindow.legendFrame.trackingArrow.hOffset = 238;
	mainWindow.legendFrame.trackingArrow.vOffset = 11;
	mainWindow.legendFrame.trackingArrow.visible = 0;
	mainWindow.legendFrame.trackingArrow.tooltip = "Currently Updating Shipment Information";
	mainWindow.legendFrame.addSubview(mainWindow.legendFrame.trackingArrow);

	//assign inital tooltips to show/hide buttons
	for (i in hiddenCarriers){
		if (eval("preferences.hide"+i+".value == 0")){
			eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".src = \"./Resources/carrierShown.png\"");
			eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".tooltip = carrierStrings[i]+\" Visible\\nClick to hide \"+carrierStrings[i]+\" Shipments\"");
		} else {
			eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".src = \"./Resources/carrierHidden.png\"");
			eval("mainWindow.legendFrame.hide"+carrierStrings[i]+".tooltip = carrierStrings[i]+\" Hidden\\nClick to show \"+carrierStrings[i]+\" Shipments\"");
		}
	}

	mainWindow.visible = 1;
}


function collapse(collapsed){
	a = new CustomAnimation(1, collapseAnimation);
	a.duration = 1000;
	a.startTime = animator.milliseconds;
	a.startOffset = mainWindow.height;
	a.collapsed = collapsed;
		
	if (collapsed == 1){	
		a.endOffset = preferences.expandedHeight.value;
	} else {
		a.endOffset = 23;
	}
	
	animations.push(a);

}


function collapseAnimation(){
	var now = animator.milliseconds;
	var t = limit( now - this.startTime, 0, this.duration );
	var percent = t / this.duration;
	
	if (this.collapsed == 1){
		upDown = .2;
	} else {
		upDown = -.2;
	}
	
	if (mainWindow.contentFrame.height < 5){
		mainWindow.contentFrame.visible = 0;
		mainWindow.scrollbar.visible = 0;
		mainWindow.frameBg.visible = 0;
	}else {
		mainWindow.contentFrame.visible = 1;
		mainWindow.scrollbar.visible = 1;
		mainWindow.frameBg.visible = 1;
	}
	
	mainWindow.height = animator.ease(this.startOffset, this.endOffset, percent + upDown, animator.kEaseNone);
	mainWindow.botBar.vOffset  = animator.ease(this.startOffset, this.endOffset - 11, percent, animator.kEaseNone);
	mainWindow.midBar.height  = animator.ease(this.startOffset, this.endOffset - 22, percent, animator.kEaseNone);

	mainWindow.contentFrame.height = animator.ease(this.startOffset -40, this.endOffset - 40, percent, animator.kEaseNone);
	mainWindow.scrollbar.height = animator.ease(this.startOffset -40, this.endOffset - 40, percent, animator.kEaseNone);
	mainWindow.frameBg.height = animator.ease(this.startOffset -40, this.endOffset - 40, percent, animator.kEaseNone);
	
	if ( animator.milliseconds/2 >= (this.startTime + this.duration)/2  ){
		mainWindow.height = this.endOffset;
		mainWindow.botBar.vOffset = mainWindow.height - 11;
		mainWindow.midBar.height = mainWindow.height - 22;
		return false;
	}
	return true;
}

function customMove(obj, toX, toY, duration, easeType){
	this.a = new CustomAnimation(1, customMoveAnimation);
	this.a.duration = duration;
	this.a.startTime = animator.milliseconds;
	this.a.startX = obj.hOffset;
	this.a.startY = obj.vOffset;
	this.a.endX = toX;
	this.a.endY = toY;
	this.a.obj = obj;
	this.a.easeType = easeType;
}


function customMoveAnimation(){
	var now = animator.milliseconds;
	var t = limit( now - this.startTime, 0, this.duration );
	var percent = t / this.duration;

	this.obj.hOffset = animator.ease(this.startX, this.endX, percent, this.easeType); 	
	this.obj.vOffset = animator.ease(this.startY, this.endY, percent, this.easeType);

	if ( animator.milliseconds >= (this.startTime + this.duration)  ){
		this.obj.hOffset = this.endX;
		this.obj.vOffset = this.endY;
		return false;
	}
	return true;
}

function limit( input, lower, upper ){
	return (input < lower) ? lower : ( (input > upper) ? upper : input);
}


function loadPlugins(){
	for (trackerItem in trackers){
		eval("include(\"./"+trackers[trackerItem]+".js\");");
	}
}


function pleaseWait(){
	delete wait;
	wait = new Array();
	wait["Container"] = new Window("Wait");
	wait["Container"].width = 355;
	wait["Container"].height = 23;
	wait["Container"].visible = 0;
	
	wait["BackgroundTop"] = new Image(wait["Container"]);
	wait["BackgroundTop"].src = "./Resources/backgroundTop.png";
	wait["BackgroundTop"].height = 11;
	wait["BackgroundTop"].width = wait["Container"].width;
	wait["BackgroundTop"].hOffset = 0;
	wait["BackgroundTop"].vOffset = 0;

	wait["BackgroundCenter"] = new Image(wait["Container"]);
	wait["BackgroundCenter"].width = wait["Container"].width;
	wait["BackgroundCenter"].height   = wait["Container"].height - 21;
	wait["BackgroundCenter"].src      = "./Resources/backgroundCenter.png";
	wait["BackgroundCenter"].colorize = "";
	wait["BackgroundCenter"].vOffset  = wait["BackgroundTop"].vOffset + wait["BackgroundTop"].height;

	wait["BackgroundBottom"] = new Image(wait["Container"]);
	wait["BackgroundBottom"].width = wait["Container"].width;
	wait["BackgroundBottom"].height   = 10;
	wait["BackgroundBottom"].src      = "./Resources/backgroundBottom.png";
	wait["BackgroundBottom"].colorize = "";	
	wait["BackgroundBottom"].vOffset  = wait["BackgroundCenter"].vOffset + wait["BackgroundCenter"].height;
	
	wait["Message"] = new Text(wait["Container"]);
	wait["Message"].data = "Retrieving latest data. This may take a moment.";
	wait["Message"].color = "#FFFFFF";
	wait["Message"].hOffset = 10;
	wait["Message"].vOffset = 17;
	wait["Message"].size = 16;
	
	wait["Container"].visible = 1;
	
	wait["Timer"] = new Timer();
	wait["Timer"].interval = 3;
	wait["Timer"].ticking = 1;
	wait["Timer"].onTimerFired = "wait[\"Container\"].visible = 0; delete wait;";
	
}

function resolveNumValue(val){
	switch(val){
		case "number":
			return "Tracking Number";
			break;
		case "description":
			return "Description";
			break;
		case "deliveredTo":
			return "Delivered To";
			break;
		case "deliveredLoc":
			return "Delivery Location";
			break;
		case "serviceType":
			return "Service Type";
			break;
		case "location":
			return "Last Known Location";
			break;
		case "carrier":
			return "Carrier";
			break;
		case "status":
			return "Status";
			break;
		case "destination":
			return "Destination";
			break;
		case "deliveryDate":
			return "Date Delivered";
			break;
		case "shipDate":
			return "Date Shipped";
			break;
		case "pieces":
			return "Number of Pieces";
			break;
		case "weight":
			return "Weight";
			break;
		case "lastUpdateDate":
			return "Last Carrier Update Date";
			break;
		case "lastUpdateTime":
			return "Last Carrier Update Time";
			break;
		case "activity":
			return "Activity";
			break;
		case "details":
			return "Details";
			break;
		case "signedBy":
			return "Signed for By";
			break;
		case "estDeliveryDate":
			return "Estimated Delivery";
			break;
		case "reference":
			return "Reference";
			break;
		case "poNumber":
			return "Purchase Order Number";
			break;
		case "invoiceNumber":;
			return "Invoice Number";
			break;
		case "deptNumber":
			return "Department Number";
			break;
		case "reschDelivery":
			return "Rescheduled Delivery";
			break;
		case "note":
			return "Note";
			break;
		case "shipBillDate":
			return "Shipped or Billed on";
			break;
		case "schDelivery":
			return "Scheduled Delivery";
			break;
		case "shipmentType":
			return "Shipment Type";
			break;
		case "origin":
			return "Origin";
			break;
		case "originCode":
			return "Origin Code";
			break;
		case "destinationCode":
			return "Destination Code";
			break;
		case "deliveryNotificationAllow":
			return "Delivery Notification Allow";
			break;
		case "receiver":
			return "Receiver";
			break;
		case "pickupLocation":
			return "Picked up at";
			break;
		case "sender":
			return "Sender";
			break;
		case "destinationAddy":
			return "Destination Address";
			break;
		case "senderAddy":
			return "Sender Address";
			break;
		case "shipmentAck":
			return "Shipment Acknowledged";
			break;
		case "tenderedUSPS":
			return "Tendered USPS";
			break;
		case "comment":
			return "Comment";
			break;			
	}
		
}

function trackingNumber(tNumber, tDescription, carrier, tPosition){

	if ((tNumber != "")||(tNumber != undefined)){
		this.number         = tNumber;
	} else {
		this.number         = "Not Provided";	
	}
	if ((tDescription != "")||(tDescription != undefined)){
		this.description    = tDescription;
	} else {
		this.description    = "Not Provided";
	}
	
	this.position		= tPosition;
	this.carrier	     	= carrier;
	this.status	     	= "Unavailable";
	this.estDeliveryDate 	= "Unavailable";
	this.schDelivery     	= "Unavailable";
	this.reschDelivery   	= "Unavailable";
	this.serviceType     	= "Unavailable";
	this.shipmentType	= "Unavailable";
	this.deliveryNotificationAllow = "Unavailable";
	this.reference		= "Unavailable";
	this.poNumber		= "Unavailable";
	this.invoiceNumber	= "Unavailable";
	this.deptNumber		= "Unavailable";
	this.pieces		= "Unavailable";
	this.weight		= "Unavailable";
	this.lastUpdateDate 	= "Unavailable";
	this.lastUpdateTime 	= "Unavailable";
	this.location	    	= "Unavailable";
	this.activity	    	= "Unavailable";	
	this.details	    	= "Unavailable";	
	this.origin		= "Unavailable";
	this.originCode		= "Unavailable";
	this.receiver		= "Unavailable";
	this.sender		= "Unavailable";
	this.senderAddy		= "Unavailable";
	this.destination	= "Unavailable";
	this.destinationCode	= "Unavailable";
	this.destinationAddy	= "Unavailable";
	this.deliveryDate   	= "Unavailable";
	this.deliveredTo    	= "Unavailable";
	this.deliveredLoc   	= "Unavailable";
	this.signedBy	    	= "Unavailable";
	this.shipmentAck	= "Unavailable";
	this.shipDate	    	= "Unavailable";
	this.tenderedUSPS	= "Unavailable";
	this.shipBillDate	= "Unavailable";
	this.pickupLocation	= "Unavailable";
	this.note		= "Unavailable";

	this.itemFrame = new Frame();
	this.itemFrame.width = mainWindow.contentFrame.width
	this.itemFrame.height = 22;
	this.itemFrame.vOffset = (tPosition + 1)* 19;
	this.itemFrame.parent = this;
	this.itemFrame.visible = 0;
	this.itemFrame.MenuItems = new Array();
	this.itemFrame.MenuItems[0] = new MenuItem();
	this.itemFrame.MenuItems[0].title = "Edit This Shipment";
	this.itemFrame.MenuItems[0].enabled = 1;
	this.itemFrame.MenuItems[0].parent = this.itemFrame;
	this.itemFrame.MenuItems[0].onSelect = "editEntry("+tPosition+",1);";
	
	this.itemFrame.MenuItems[1] = new MenuItem();
	this.itemFrame.MenuItems[1].title = "View Shipment Details";
	this.itemFrame.MenuItems[1].enabled = 1;
	this.itemFrame.MenuItems[1].parent = this.itemFrame;
	this.itemFrame.MenuItems[1].onSelect = "trackNow("+tPosition+", 0);";

	this.itemFrame.MenuItems[2] = new MenuItem();
	this.itemFrame.MenuItems[2].title = "Visit Tracking Webpage";
	this.itemFrame.MenuItems[2].enabled = 1;
	this.itemFrame.MenuItems[2].parent = this.itemFrame;
	this.itemFrame.MenuItems[2].onSelect = "webLink("+tPosition+");";
	
	this.itemFrame.MenuItems[3] = new MenuItem();
	this.itemFrame.MenuItems[3].title = "Delete This Shipment";
	this.itemFrame.MenuItems[3].enabled = 1;
	this.itemFrame.MenuItems[3].parent = this.itemFrame;
	this.itemFrame.MenuItems[3].onSelect = "deleteEntry("+tPosition+");";	
		
	this.itemFrame.MenuItems[4] = new MenuItem();
	this.itemFrame.MenuItems[4].parent = this.itemFrame;
	this.itemFrame.MenuItems[4].title = "-";
	this.itemFrame.MenuItems[4].enabled = 0;
	
	this.itemFrame.contextMenuItems = this.itemFrame.MenuItems;
	
	this.itemFrame.onMultiClick = function(){
		if (preferences.dblClickAction.value == "updateInfo"){
			trackNow(this.parent.position, 1);
		} else if (preferences.dblClickAction.value == "displayDetails"){
			trackNow(this.parent.position, 0);
		} else if (preferences.dblClickAction.value == "none"){
		} else if (preferences.dblClickAction.value == "weblink"){
			webLink(this.parent.position);
		}
	}
	
	this.watch("position", 
		function(id,oldval,newval){
			displayedNumbers[newval].itemFrame.MenuItems[0].onSelect = "editEntry("+newval+");";
			displayedNumbers[newval].itemFrame.MenuItems[1].onSelect = "trackNow("+newval+");";
			displayedNumbers[newval].itemFrame.MenuItems[2].onSelect = "webLink("+newval+");";
			displayedNumbers[newval].itemFrame.MenuItems[3].onSelect = "deleteEntry("+newval+");";
			return newval;
		}
	);

	this.readout 		= new Array();
	this.readout.parent = this;
	this.readout.description= new Text();
	this.readout.description.parent=this.readout;
	this.readout.description.data	= "    "+this.description;
	if (this.readout.description.data == ""){this.readout.description.data = " ";}
	this.readout.description.color	="#FFFFFF";
	this.readout.description.width  = mainWindow.contentFrame.width;
	
	if(carrier == "ups"){
		this.readout.description.bgColor="#8A8446";}
	else if(carrier == "fedex"){
		this.readout.description.bgColor="#0000AA";}
	else if(carrier == "dhl"){
		this.readout.description.bgColor="#AAAA00";}
	else if(carrier == "usps"){
		this.readout.description.bgColor="#AA0000";}
	else if(carrier == "puro"){
		this.readout.description.bgColor="#AA00AA";}		

	this.readout.description.bgOpacity=255;
	this.readout.description.shadow	=defaultShadow;
	this.readout.description.size	=16;
	this.readout.description.vOffset= 18;
	this.readout.description.hOffset= 2;
	this.itemFrame.addSubview(this.readout.description);
	
	this.readout.status = new Image();
	this.readout.status.parent  = this.readout;
	this.readout.status.src	   = "./Resources/unknown.png";
	this.readout.status.height = 16;
	this.readout.status.width  = 16;
	this.readout.status.tooltip= "Not Yet Tracked";
	this.readout.status.vOffset= 5;
	this.readout.status.hOffset= 3;
	this.itemFrame.addSubview(this.readout.status);
	
	mainWindow.contentFrame.addSubview(this.itemFrame);
	
	eval("this.itemFrame.visible = ! Number(preferences.hide"+this.carrier+".value)");
}

function addTrackingNumber(position, edit){
	
	if (edit == 1){
		defaultCarrier = displayedNumbers[position].carrier;
		defaultTrackingNumber = displayedNumbers[position].number;
		defaultDescription = displayedNumbers[position].description;
	}else{
		defaultCarrier="ups";
		defaultTrackingNumber = "";
		defaultDescription = "";
	}

	formFields = new Array();

	formFields[0] = new FormField();
	formFields[0].title = "Carrier";
	formFields[0].defaultValue = defaultCarrier;
	formFields[0].type="popup";
	formFields[0].option = new Array();
	formFields[0].optionValue= new Array();
	for (items in carrierStrings){
		formFields[0].option.push(carrierStrings[items]);
		formFields[0].optionValue.push(items);
		print(items);
		print(carrierStrings[items]);
		
	}

	formFields[1] = new FormField();
	formFields[1].title = "Tracking Number:";
	formFields[1].type  = "text";
	formFields[1].defaultValue = defaultTrackingNumber;

	formFields[2] = new FormField();
	formFields[2].title = "Description:";
	formFields[2].type  = "text";
	formFields[2].defaultValue = defaultDescription;
	

	if (edit == 1){
		formResults = form(formFields, "Edit an existing shipment", "Update", "Cancel");
	}else {
		formResults = form(formFields, "Track a new shipment", "Add", "Cancel");
	}



	if(formResults){

		carrier = formResults[0]
			
		if (preferences.trackingNumbers.value == ""){
			tempNumbers = new Array();
			tempDescriptions = new Array();
			tempCarriers = new Array();
		}else {
			tempNumbers = preferences.trackingNumbers.value.split("|");
			tempDescriptions = preferences.trackingDescriptions.value.split("|");
			tempCarriers = preferences.trackingCarriers.value.split("|");
		}
		
		if (edit != 1){
			tempCarriers.push(formResults[0]);
			tempNumbers.push(formResults[1]);
			tempDescriptions.push(formResults[2]);
		} else {
			tempCarriers[position] = formResults[0];
			tempNumbers[position] = formResults[1];
			tempDescriptions[position] = formResults[2];
		}
				
		preferences.trackingNumbers.value = tempNumbers.join("|");
		preferences.trackingDescriptions.value = tempDescriptions.join("|");
		preferences.trackingCarriers.value = tempCarriers.join("|");
		
		
		savePreferences();

		if (edit == 1){
			for(items in displayedNumbers[position].readout){
				eval("displayedNumbers[position].readout."+items+".visible = 0");
			}
			displayedNumbers[position].itemFrame.visible=0;
			displayedNumbers[position]= new trackingNumber(formResults[1],formResults[2],formResults[0],position);
		}else {
			position = displayedNumbers.length;
			displayedNumbers[position]= new trackingNumber(formResults[1],formResults[2],formResults[0],position);
		}

	
		eval(carrier+"Track(formResults[1],position,1)");
	}
	

	
	
}

function migratePreferencesFrom302(){
	migrationNumbers = new Array();
	migrationDescriptions = new Array();
	migrationCarriers = new Array();
	
	
	for (items in trackers){
		if (items != "puro"){
		$_ = trackers[items];
		try{
			if(eval("preferences."+$_+"Numbers.value") != ""){
				eval("tempNumbers = preferences."+$_+"Numbers.value.split(\"|\")");
				eval("tempDescriptions = preferences."+$_+"Descriptions.value.split(\"|\")");
				
				for(i in tempNumbers){
					migrationNumbers.push(tempNumbers[i]);
					migrationDescriptions.push(tempDescriptions[i]);
					migrationCarriers.push($_);
				}
		
				eval("preferences."+$_+"Numbers.value = \"\"");
				eval("preferences."+$_+"Descriptions.value = \"\"");
				eval("preferences."+$_+"Active.value = \"\"");
				eval("preferences."+$_+"Timer.value = \"\"");
				eval("preferences."+$_+"Startup.value = \"\"");
				eval("preferences."+$_+"BgColor.value = \"\"");
				eval("preferences."+$_+"FontColor.value = \"\"");
			}
		}
		catch(er){}
		}
	}
	
	preferences.trackingNumbers.value = migrationNumbers.join("|");
	preferences.trackingDescriptions.value = migrationDescriptions.join("|");
	preferences.trackingCarriers.value = migrationCarriers.join("|");

	preferences.previousVersion.value = widget.version;
	savePreferences();
		
}

function generateInitialDisplay(){
	
	if (preferences.trackingNumbers.value != ""){
		tempNumbers = preferences.trackingNumbers.value.split("|");
		tempDescriptions = preferences.trackingDescriptions.value.split("|");
		tempCarriers = preferences.trackingCarriers.value.split("|");
	
		for (i in tempNumbers){
			position = displayedNumbers.length;
			displayedNumbers[position]= new trackingNumber(tempNumbers[i],tempDescriptions[i],tempCarriers[i],position);
		}
		
	animations = new Array();	
	actuallyDisplayed = -1;
	for (i in displayedNumbers){

		if(hiddenCarriers[displayedNumbers[i].carrier] == 1){
			displayedNumbers[i].itemFrame.visible = 0;
		}

		actuallyDisplayed += displayedNumbers[i].itemFrame.visible;
		
		if (actuallyDisplayed == -1){
			a = new customMove(displayedNumbers[i].itemFrame, displayedNumbers[i].itemFrame.hOffset, 19, 1000, animator.kEaseInOut);
		}else {
			a = new customMove(displayedNumbers[i].itemFrame, displayedNumbers[i].itemFrame.hOffset, actuallyDisplayed*19+19, 1000, animator.kEaseInOut);
		}
		
		animations.push(a.a);

	}

	animator.start(animations);

		
	}
}

function preferencesChanged(){

	mainWindow.level = preferences.konfabulatorWindowLevel.value;
	mainWindow.locked = preferences.konfabulatorLockWindowPosition.value;
	mainWindow.opacity = preferences.konfabulatorWindowOpacity.value;
	mainWindow.topBar.colorize = preferences.bezelColor.value;
	mainWindow.midBar.colorize = preferences.bezelColor.value;
	mainWindow.botBar.colorize = preferences.bezelColor.value;
	mainWindow.collapseButton.colorize = preferences.bezelColor.value;
	mainWindow.addButton.colorize = preferences.bezelColor.value;


	if (preferences.updateFreq.value == 0){
		updateTimer.ticking = 0;}
	else{
		updateTimer.interval = preferences.updateFreq.value * 60 * 60;
		updateTimer.ticking = 1;}
		
	toggleTimer.interval = preferences.toggleInt.value;


}


function webLink(position){
	eval(displayedNumbers[position].carrier+"Webpage(displayedNumbers[position].number)");
}

function editEntry(position){
	addTrackingNumber(position, 1);
}

function deleteEntry(position){

	if (1 == alert("Are you certain you wish to delete entry:\n\""+displayedNumbers[position].description+"\"?", "Yes", "No")){
		displayedNumbers[position].unwatch("position");
		displayedNumbers[position].itemFrame.visible = 0;
		
		displayedNumbers[position].readout.visible = 0;
		displayedNumbers[position].readout.description.visible = 0;
		displayedNumbers[position].readout.status.visible = 0;	

		tempNumbers = preferences.trackingNumbers.value.split("|");
		tempDescriptions = preferences.trackingDescriptions.value.split("|");
		tempCarriers = preferences.trackingCarriers.value.split("|");
		
		tempNumbers.splice(position,1);
		tempDescriptions.splice(position,1);
		tempCarriers.splice(position,1);
		
		preferences.trackingNumbers.value = tempNumbers.join("|");
		preferences.trackingDescriptions.value = tempDescriptions.join("|");
		preferences.trackingCarriers.value = tempCarriers.join("|");
		
		savePreferences();
		
		displayedNumbers.splice(position, 1);
		animations = new Array();
		actuallyDisplayed = -1;

		for (i in displayedNumbers){
			displayedNumbers[i].position = i;

			actuallyDisplayed += displayedNumbers[i].itemFrame.visible;

			a = new customMove(displayedNumbers[i].itemFrame, displayedNumbers[i].itemFrame.hOffset, actuallyDisplayed*19+19, 1000, animator.kEaseInOut);
			animations.push(a.a);
		}
		
		animator.start(animations);
	}
}

function trackNow(position, auto){
	eval(displayedNumbers[position].carrier+"Track(\""+displayedNumbers[position].number+"\","+position+", "+auto+")");
}

function hideCarrier(carrier, batch){
	suppressUpdates();
	if(hiddenCarriers[carrier] == 1){
		hiddenCarriers[carrier] = 0;
	}else{
		hiddenCarriers[carrier] = 1;
	}
	
	eval("preferences.hide"+carrier+".value = "+hiddenCarriers[carrier]);
	
	savePreferences();
	
		animations = new Array();	
		actuallyDisplayed = -1;

		for (i in displayedNumbers){
	
			if (displayedNumbers[i].carrier == carrier){
				displayedNumbers[i].itemFrame.visible = ! displayedNumbers[i].itemFrame.visible;		
			}
	
			actuallyDisplayed += displayedNumbers[i].itemFrame.visible;

			if (actuallyDisplayed*19+19 < 19){
				newOffset = 19;}
			else {
				newOffset = actuallyDisplayed*19+19;}
			
			a = new customMove(displayedNumbers[i].itemFrame, displayedNumbers[i].itemFrame.hOffset, newOffset, 1000, animator.kEaseInOut);
			animations.push(a.a);

		}
	
	if (batch != 1){
		resumeUpdates();
		animator.start(animations);
	}

}




updateTimer = new Timer();
updateTimer.interval=3600;
updateTimer.ticking =1;
if (preferences.updateFreq.value == 0){
	updateTimer.ticking = 0;}
else{
	updateTimer.interval = preferences.updateFreq.value * 60 * 60;
	updateTimer.ticking = 1;}
	
function updateTimeronTimerFired(){
	mainWindow.legendFrame.trackingArrow.visible = 1;
	rotateTimer.ticking = 1;
	toggleTimer.iter = -1;
	toggleTimer.ticking = 1;
	checkForUpdates();
}
updateTimer.onTimerFired = "updateTimeronTimerFired()";

rotateTimer = new Timer();
rotateTimer.interval=1;
rotateTimer.ticking=0;
function rotateTimeronTimerFired(){
	mainWindow.legendFrame.trackingArrow.rotation += 20;
	updateNow();}
rotateTimer.onTimerFired = "rotateTimeronTimerFired()";


startupCheck = new Timer();
startupCheck.interval = 5;
startupCheck.ticking = preferences.updateOnLoad.value;
function startupCheckonTimerFired(){
	startupCheck.ticking = 0;
	updateTimeronTimerFired();
	toggleTimeronTimerFired();
}
startupCheck.onTimerFired = "startupCheckonTimerFired()";

toggleTimer = new Timer();
toggleTimer.interval=preferences.toggleInt.value;
toggleTimer.ticking = 0;
toggleTimer.iter = -1;
function toggleTimeronTimerFired(){
	toggleTimer.iter++;
	
	try{if(url.cancel() == "undefined"){}}
	catch(er){}
	
	if (toggleTimer.iter >= displayedNumbers.length){
		mainWindow.legendFrame.trackingArrow.visible = 0;
		rotateTimer.ticking = 0;
		toggleTimer.iter = -1;
		toggleTimer.ticking = 0;		
	} else {;
		eval(displayedNumbers[toggleTimer.iter].carrier+"Track(displayedNumbers["+toggleTimer.iter+"].number,"+toggleTimer.iter+",1)");
	}
	updateNow();
}
toggleTimer.onTimerFired = "toggleTimeronTimerFired()";

currentlyDeleting = 0;
displayedNumbers = new Array();
hiddenCarriers = new Array();
carrierStrings = new Array();
hiddenCarriers["ups"] = preferences.hideups.value;
carrierStrings["ups"] = "UPS";
hiddenCarriers["fedex"] = preferences.hidefedex.value;
carrierStrings["fedex"] = "FedEx";
hiddenCarriers["dhl"] = preferences.hidedhl.value;
carrierStrings["dhl"] = "DHL";
hiddenCarriers["usps"] = preferences.hideusps.value;
carrierStrings["usps"] = "USPS";
hiddenCarriers["puro"] = preferences.hideusps.value;
carrierStrings["puro"] = "Purolator";

trackers = new Array("ups", "fedex", "dhl", "usps", "puro"); //store the list of trackers


if (preferences.previousVersion.value==""){
	migratePreferencesFrom302();}
else if (versionCheck(preferences.previousVersion.value, "4.1.0") == "<"){
	if (1 == alert("This new version of the UST adds support for Purolator shipments, and adds a double click functionality to your shipments for ease of use.\nWould you like to set this in your preferences now?", "Yes", "No")){
		showWidgetPreferences();
	}
}






createConsole();
generateInitialDisplay();
loadPlugins();

preferences.previousVersion.value = widget.version;
savePreferences();

if (preferences.expandOnLoad.value == 1){
	mainWindow.collapseButton.arrow.onMouseUp();
}

