	uspsDetailsWindow = new Array(); 
	function uspsDetails(entry){
		$_ = displayedNumbers[entry];
		
		uspsDetailsWindow[entry] = new Array();
		uspsDetailsWindow[entry]["Container"] = new Window("details"+entry);
		uspsDetailsWindow[entry]["Container"].height = 300;
		uspsDetailsWindow[entry]["Container"].width  = 300;
		uspsDetailsWindow[entry]["Container"].visible = 1;

		uspsDetailsWindow[entry]["BackgroundTop"] = new Image(uspsDetailsWindow[entry]["Container"]);
		uspsDetailsWindow[entry]["BackgroundTop"].width    = uspsDetailsWindow[entry]["Container"].width;
		uspsDetailsWindow[entry]["BackgroundTop"].height   = 10;
		uspsDetailsWindow[entry]["BackgroundTop"].src      = "./Resources/backgroundTop.png";
		uspsDetailsWindow[entry]["BackgroundTop"].colorize = preferences.bezelColor.value;

		uspsDetailsWindow[entry]["BackgroundCenter"] = new Image(uspsDetailsWindow[entry]["Container"]);
		uspsDetailsWindow[entry]["BackgroundCenter"].width    = uspsDetailsWindow[entry]["Container"].width;
		uspsDetailsWindow[entry]["BackgroundCenter"].height   = 280;
		uspsDetailsWindow[entry]["BackgroundCenter"].src      = "./Resources/backgroundCenter.png";
		uspsDetailsWindow[entry]["BackgroundCenter"].colorize = preferences.bezelColor.value;
		uspsDetailsWindow[entry]["BackgroundCenter"].vOffset  = uspsDetailsWindow[entry]["BackgroundTop"].vOffset + uspsDetailsWindow[entry]["BackgroundTop"].height;

		uspsDetailsWindow[entry]["BackgroundBottom"] = new Image(uspsDetailsWindow[entry]["Container"]);
		uspsDetailsWindow[entry]["BackgroundBottom"].width    = uspsDetailsWindow[entry]["Container"].width;
		uspsDetailsWindow[entry]["BackgroundBottom"].height   = 10;
		uspsDetailsWindow[entry]["BackgroundBottom"].src      = "./Resources/backgroundBottom.png";
		uspsDetailsWindow[entry]["BackgroundBottom"].colorize = preferences.bezelColor.value;	
		uspsDetailsWindow[entry]["BackgroundBottom"].vOffset  = uspsDetailsWindow[entry]["BackgroundCenter"].vOffset + uspsDetailsWindow[entry]["BackgroundCenter"].height;

		uspsDetailsWindow[entry]["Details"] = new TextArea(uspsDetailsWindow[entry]["Container"]);
		dataStr = "";
		for (items in displayedNumbers[entry]){
		$_ = displayedNumbers[entry][items];
			if (($_ != "Unavailable")
			  &&(items != "itemFrame") 
			  &&(items != "position")
			  &&(items != "readout"))
			{
				dataStr += resolveNumValue(items) +": "+$_+"\n";
			}
		}
		uspsDetailsWindow[entry]["Details"].data	   = dataStr;
		uspsDetailsWindow[entry]["Details"].font    = "Verdana";
		uspsDetailsWindow[entry]["Details"].color   = preferences.fontColor.value;
		uspsDetailsWindow[entry]["Details"].size    = 12;
		uspsDetailsWindow[entry]["Details"].hOffset = 10;
		uspsDetailsWindow[entry]["Details"].vOffset = 10;
		uspsDetailsWindow[entry]["Details"].width   = 286;
		uspsDetailsWindow[entry]["Details"].height  = 270;
		uspsDetailsWindow[entry]["Details"].editable = 0;
		if (dataStr.split("\n").length > 18){
			uspsDetailsWindow[entry]["Details"].scrollbar = "";
			uspsDetailsWindow[entry]["Details"].scrollbar = 1;		
		} else{
			uspsDetailsWindow[entry]["Details"].scrollbar = "";
			uspsDetailsWindow[entry]["Details"].scrollbar = 0;
		}


		uspsDetailsWindow[entry]["Close"] = new Image(uspsDetailsWindow[entry]["Container"]);
		uspsDetailsWindow[entry]["Close"].src       = "./Resources/closeon.png";
		uspsDetailsWindow[entry]["Close"].height    = 16;
		uspsDetailsWindow[entry]["Close"].width     = 16;
		uspsDetailsWindow[entry]["Close"].vOffset   = uspsDetailsWindow[entry]["Container"].height - 20;
		uspsDetailsWindow[entry]["Close"].hOffset   = uspsDetailsWindow[entry]["Container"].width - 20;
		uspsDetailsWindow[entry]["Close"].tooltip   = "Close this window";
		uspsDetailsWindow[entry]["Close"].onMouseDown = function(){
			uspsDetailsWindow[entry]["Close"].src       = "./Resources/close.png";}
		uspsDetailsWindow[entry]["Close"].onMouseUp = function(){
			uspsDetailsWindow[entry]["Close"].src       = "./Resources/closeon.png";
			uspsDetailsWindow[entry]["Container"].visible = 0;}
			
		
	}

	function uspsAutocheck(){
		for (items in displayedNumbers){
			$_ = displayedNumbers[items]; // cause I like the default value from perl.
			uspsTrack($_.number, items, 1);
		}
	}

	function uspsTrack(tNumber, entry, automatic){
		if (automatic != 1){pleaseWait();}
		url = new URL();
		url.location = "http://trkcnfrm1.smi.usps.com/PTSInternetWeb/InterLabelInquiry.do?strOrigTrackNum="+tNumber.replace(" ", "");
		url.entry = entry;
		url.tNumber = tNumber;
		url.automatic = automatic;
		url.fetchAsync(uspsProcessResults);
	}
	
	function uspsProcessResults( url ){
		if (url.response == 200){
			results = url.result;
			if (results.match("There is no record of this item")){
				displayedNumbers[url.entry].status = "There is no record of this item";
			
			} else if (results.match("Additional information for this item is stored in files offline.")){
				resultsArray = results.split("summary=\"This table is used to format page content.\"");
				resultsArray = resultsArray[3].split("<tr>");
				resultsArray = resultsArray[4].split("<td");
				resultsArray = resultsArray[2].split("\n");
				for (items in resultsArray){
					$_ = resultsArray[items];
					if ($_.match("Status:")){
						$_ = $_.match(/<span[^>]+>(\S.*[^<]+)<\/span>/ig);
						$_ = $_[0].match(/>(\S.*)</)[1];
						displayedNumbers[url.entry].status = $_;
					} else if ($_.match(/Your item/i)){
						$_ = $_.match(/(\S.*)/)[0];
						displayedNumbers[url.entry].details = $_;
					}
				}
			} else {
							resultsArray = results.split("summary=\"This table is used to format page content.\"");
							resultsArray = resultsArray[3].split("<tr>");
							resultsArray = resultsArray[4].split("<td");
							resultsArray = resultsArray[2].split("\n");
							for (items in resultsArray){
								$_ = resultsArray[items];
								if ($_.match("Status:")){
									$_ = $_.match(/<span[^>]+>(\S.*[^<]+)<\/span>/ig);
									$_ = $_[0].match(/>(\S.*)</)[1];
									displayedNumbers[url.entry].status = $_;
								} else if ($_.match(/Your item/i)){
									$_ = $_.match(/(\S.*)/)[0];
									displayedNumbers[url.entry].details = $_;
								}
							}
			}

			if(displayedNumbers[url.entry].status == "Arrival at Unit"){
				displayedNumbers[url.entry].readout.status.src = "./Resources/box.png";
				displayedNumbers[url.entry].readout.status.tooltip = "Delivered";
			} else if(displayedNumbers[url.entry].status == "Delivered"){
				displayedNumbers[url.entry].readout.status.src = "./Resources/box.png";
				displayedNumbers[url.entry].readout.status.tooltip = "Delivered";
			} else if (displayedNumbers[url.entry].status.match("Enroute")){
				displayedNumbers[url.entry].readout.status.src = "./Resources/truck.png";
				displayedNumbers[url.entry].readout.status.tooltip = displayedNumbers[url.entry].status;
			} else if ((displayedNumbers[url.entry].status == "There is no record of this item")||
					   (displayedNumbers[url.entry].status == "Unavailable")){
				displayedNumbers[url.entry].readout.status.src = "./Resources/exclaimation.png";
				displayedNumbers[url.entry].readout.status.tooltip = displayedNumbers[url.entry].status;
			} else if (displayedNumbers[url.entry].status == "Electronic Shipping Info Received"){
				displayedNumbers[url.entry].readout.status.src = "./Resources/moneybag.png";
				displayedNumbers[url.entry].readout.status.tooltip = displayedNumbers[url.entry].status;
			}
			
			if (url.automatic != 1){uspsDetails(url.entry);}
		} else {
			displayedNumbers[url.entry].readout.status.src = "./Resources/exclaimation.png";
			displayedNumbers[url.entry].readout.status.tooltip = "Error Retrieving Page";
		}
		displayedNumbers[url.entry].readout.status.reload();
	}

function uspsWebpage(tNumber){
	openURL("http://trkcnfrm1.smi.usps.com/PTSInternetWeb/InterLabelInquiry.do?strOrigTrackNum="+tNumber.replace(" ", ""));
}