	puroDetailsWindow = new Array(); 
	function puroDetails(entry){
		$_ = displayedNumbers[entry];
		
		puroDetailsWindow[entry] = new Array();
		puroDetailsWindow[entry]["Container"] = new Window("details"+entry);
		puroDetailsWindow[entry]["Container"].height = 300;
		puroDetailsWindow[entry]["Container"].width  = 300;
		puroDetailsWindow[entry]["Container"].visible = 1;

		puroDetailsWindow[entry]["BackgroundTop"] = new Image(puroDetailsWindow[entry]["Container"]);
		puroDetailsWindow[entry]["BackgroundTop"].width    = puroDetailsWindow[entry]["Container"].width;
		puroDetailsWindow[entry]["BackgroundTop"].height   = 10;
		puroDetailsWindow[entry]["BackgroundTop"].src      = "./Resources/backgroundTop.png";
		puroDetailsWindow[entry]["BackgroundTop"].colorize = preferences.bezelColor.value;

		puroDetailsWindow[entry]["BackgroundCenter"] = new Image(puroDetailsWindow[entry]["Container"]);
		puroDetailsWindow[entry]["BackgroundCenter"].width    = puroDetailsWindow[entry]["Container"].width;
		puroDetailsWindow[entry]["BackgroundCenter"].height   = 280;
		puroDetailsWindow[entry]["BackgroundCenter"].src      = "./Resources/backgroundCenter.png";
		puroDetailsWindow[entry]["BackgroundCenter"].colorize = preferences.bezelColor.value;
		puroDetailsWindow[entry]["BackgroundCenter"].vOffset  = puroDetailsWindow[entry]["BackgroundTop"].vOffset + puroDetailsWindow[entry]["BackgroundTop"].height;

		puroDetailsWindow[entry]["BackgroundBottom"] = new Image(puroDetailsWindow[entry]["Container"]);
		puroDetailsWindow[entry]["BackgroundBottom"].width    = puroDetailsWindow[entry]["Container"].width;
		puroDetailsWindow[entry]["BackgroundBottom"].height   = 10;
		puroDetailsWindow[entry]["BackgroundBottom"].src      = "./Resources/backgroundBottom.png";
		puroDetailsWindow[entry]["BackgroundBottom"].colorize = preferences.bezelColor.value;	
		puroDetailsWindow[entry]["BackgroundBottom"].vOffset  = puroDetailsWindow[entry]["BackgroundCenter"].vOffset + puroDetailsWindow[entry]["BackgroundCenter"].height;

		puroDetailsWindow[entry]["Details"] = new TextArea(puroDetailsWindow[entry]["Container"]);
		dataStr = "";
		for (items in displayedNumbers[entry]){
		$_ = displayedNumbers[entry][items];
			if (($_ != "Unavailable")
			  &&(items != "itemFrame") 
			  &&(items != "position")
			  &&(items != "readout"))
			{
				dataStr += resolveNumValue(items) +": "+$_+"\n";
			}
		}
		puroDetailsWindow[entry]["Details"].data	   = dataStr;
		puroDetailsWindow[entry]["Details"].font    = "Verdana";
		puroDetailsWindow[entry]["Details"].color   = preferences.fontColor.value;
		puroDetailsWindow[entry]["Details"].size    = 12;
		puroDetailsWindow[entry]["Details"].hOffset = 10;
		puroDetailsWindow[entry]["Details"].vOffset = 10;
		puroDetailsWindow[entry]["Details"].width   = 286;
		puroDetailsWindow[entry]["Details"].height  = 270;
		puroDetailsWindow[entry]["Details"].editable = 0;
		if (dataStr.split("\n").length > 18){
			puroDetailsWindow[entry]["Details"].scrollbar = "";
			puroDetailsWindow[entry]["Details"].scrollbar = 1;		
		} else{
			puroDetailsWindow[entry]["Details"].scrollbar = "";
			puroDetailsWindow[entry]["Details"].scrollbar = 0;
		}


		puroDetailsWindow[entry]["Close"] = new Image(puroDetailsWindow[entry]["Container"]);
		puroDetailsWindow[entry]["Close"].src       = "./Resources/closeon.png";
		puroDetailsWindow[entry]["Close"].height    = 16;
		puroDetailsWindow[entry]["Close"].width     = 16;
		puroDetailsWindow[entry]["Close"].vOffset   = puroDetailsWindow[entry]["Container"].height - 20;
		puroDetailsWindow[entry]["Close"].hOffset   = puroDetailsWindow[entry]["Container"].width - 20;
		puroDetailsWindow[entry]["Close"].tooltip   = "Close this window";
		puroDetailsWindow[entry]["Close"].onMouseDown = function(){
			puroDetailsWindow[entry]["Close"].src       = "./Resources/close.png";}
		puroDetailsWindow[entry]["Close"].onMouseUp = function(){
			puroDetailsWindow[entry]["Close"].src       = "./Resources/closeon.png";
			puroDetailsWindow[entry]["Container"].visible = 0;}
			
		
	}

	function puroAutocheck(){
		for (items in displayedNumbers){
			$_ = displayedNumbers[items]; // cause I like the default value from perl.
			puroTrack($_.number, items, 1);
		}
	}

	function puroTrack(tNumber, entry, automatic){
		if (automatic != 1){pleaseWait();}
		url = new URL();
		url.location = "http://shipnow.purolator.com/shiponline/track/moreDetailsWeb.asp?pin="+tNumber.replace(" ", "")+"&refno=&lang=E&key=&deliveryStatus=&deliveryDateTime=&depot=&trackingPhoneNumber=&confirmationNumber=&pickupContactName=&pickupAddress1=&pickupAddress2=&pickupLocation=Text&predictedDelivery=&deliveredToCompany=&deliveryAddress=&deliveryLocation=&deliveryRecipient=&premiumServiceText=&productTypeText=&specialHandlingText=&paymentTypeText=&destinationPostalCode=";
		url.setRequestHeader("Referrer", "http://shipnow.purolator.com/ShipOnline/Track/moreDetailsFramesetWeb.asp");
		url.entry = entry;
		url.tNumber = tNumber;
		url.automatic = automatic;
		url.fetchAsync(puroProcessResults);
	}
	
	function puroProcessResults( url ){
		if (url.response == 200){
			results = url.result;
			results = results.replace("\n|\r", "");
			if (results.match("CLASS=\"ERRORMESSAGE\"")){
				displayedNumbers[url.entry].status = "There is no record of this item";
			} else {
				if (results.match(/<!-- table containing shipment information start -->(.*[^<]+)<!-- table containing shipment information end -->/)){
					basicShipInfo = results.match(/<!-- table containing shipment information start -->(.*[^<]+)<!-- table containing shipment information end -->/)[1];
					basicShipInfo = basicShipInfo.replace("</TR>", "");
					basicShipInfo = basicShipInfo.split("<TR>");
					for (rows in basicShipInfo){
						if (basicShipInfo[rows].match("Total Pieces")){
							if (basicShipInfo[2].match(/<FONT[^>]+>.*[^<]+<\/FONT> <FONT[^>]+>(.*[^<]+)<\/FONT>/)){
								displayedNumbers[url.entry].pieces = basicShipInfo[2].match(/<FONT[^>]+>.*[^<]+<\/FONT> <FONT[^>]+>(.*[^<]+)<\/FONT>/)[1];
							}
						} else if (basicShipInfo[rows].match("Package Details")){
							displayedNumbers[url.entry].destination = "";

							for (j in basicShipInfo[4].match(/<FONT[^>]+>.*[^<]+<\/FONT><BR><FONT[^>]+>(.*[^<]+)<\/FONT><BR><FONT[^>]+>(.*[^<]+)<\/FONT>/)){
								if ((j != 0) && (j != "index") && (j != "input") &&(basicShipInfo[4].match(/<FONT[^>]+>.*[^<]+<\/FONT><BR><FONT[^>]+>(.*[^<]+)<\/FONT><BR><FONT[^>]+>(.*[^<]+)<\/FONT>/)[j] != "")){
									displayedNumbers[url.entry].destination += basicShipInfo[4].match(/<FONT[^>]+>.*[^<]+<\/FONT><BR><FONT[^>]+>(.*[^<]+)<\/FONT><BR><FONT[^>]+>(.*[^<]+)<\/FONT>/)[j]+"\n";
								}
							}
						}
					}
				}
				
				if (results.match("<!-- table containing detailed status information start -->")){
					detailedShipInfo = results.split("<!-- table containing detailed status information start -->")[1];
					detailedShipInfo = detailedShipInfo.split("<!-- table containing detailed status information end -->")[0];
					detailedShipInfo = detailedShipInfo.replace("</TR>", "");
					detailedShipInfo = detailedShipInfo.split("<TR>");
					detailedShipInfo.shift(); //get rid of the headers
					
					detailedShipInfo = detailedShipInfo[0].split("<TD");
					detailedShipInfo.shift(); //drop empty first element
					for (items in detailedShipInfo){
						detailedShipInfo[items] = detailedShipInfo[items].replace("</TD>", "");
						detailedShipInfo[items] = detailedShipInfo[items].replace("</FONT>", "");
						detailedShipInfo[items] = detailedShipInfo[items].replace("<FONT CLASS=\"DATATEXT\">", "");
						detailedShipInfo[items] = detailedShipInfo[items].replace(" NOWRAP ALIGN='center' VALIGN='top' BGCOLOR='white'>", "");
						detailedShipInfo[items] = detailedShipInfo[items].replace(" BGCOLOR='white'>", "");
					}
					displayedNumbers[url.entry].lastUpdateDate = detailedShipInfo[0]
					displayedNumbers[url.entry].lastUpdateTime = detailedShipInfo[1]
					displayedNumbers[url.entry].details = detailedShipInfo[2]
					displayedNumbers[url.entry].comment = detailedShipInfo[3]
					
					if (displayedNumbers[url.entry].details.match("Delivered to")){
						displayedNumbers[url.entry].status = "Delivered";
					} else if (displayedNumbers[url.entry].details.match("On vehicle for delivery")){
						displayedNumbers[url.entry].status = "In Transit";
					} else if (displayedNumbers[url.entry].details.match("Left")){
						displayedNumbers[url.entry].status = "In Transit";
					} else if (displayedNumbers[url.entry].details.match("In Transit")){
						displayedNumbers[url.entry].status = "In Transit";
					}
					
				}

			}

			if(displayedNumbers[url.entry].status == "Delivered"){
				displayedNumbers[url.entry].readout.status.src = "./Resources/box.png";
				displayedNumbers[url.entry].readout.status.tooltip = "Delivered";
			} else if (displayedNumbers[url.entry].status.match("In Transit")){
				displayedNumbers[url.entry].readout.status.src = "./Resources/truck.png";
				displayedNumbers[url.entry].readout.status.tooltip = displayedNumbers[url.entry].status;
			} else if ((displayedNumbers[url.entry].status == "There is no record of this item")||
					   (displayedNumbers[url.entry].status == "Unavailable")){
				displayedNumbers[url.entry].readout.status.src = "./Resources/exclaimation.png";
				displayedNumbers[url.entry].readout.status.tooltip = displayedNumbers[url.entry].status;
			} else if (displayedNumbers[url.entry].status == "Received"){
				displayedNumbers[url.entry].readout.status.src = "./Resources/moneybag.png";
				displayedNumbers[url.entry].readout.status.tooltip = displayedNumbers[url.entry].status;
			}
			
			if (url.automatic != 1){puroDetails(url.entry);}
		} else {
			displayedNumbers[url.entry].readout.status.src = "./Resources/exclaimation.png";
			displayedNumbers[url.entry].readout.status.tooltip = "Error Retrieving Page";
		}
		displayedNumbers[url.entry].readout.status.reload();
	}

function puroWebpage(tNumber){
	openURL("http://shipnow.purolator.com/shiponline/track/moreDetailsWeb.asp?pin="+tNumber.replace(" ", "")+"&refno=&lang=E&key=&deliveryStatus=&deliveryDateTime=&depot=&trackingPhoneNumber=&confirmationNumber=&pickupContactName=&pickupAddress1=&pickupAddress2=&pickupLocation=Text&predictedDelivery=&deliveredToCompany=&deliveryAddress=&deliveryLocation=&deliveryRecipient=&premiumServiceText=&productTypeText=&specialHandlingText=&paymentTypeText=&destinationPostalCode=");
}