	upsDetailsWindow = new Array(); 
	function upsDetails(entry){
		$_ = displayedNumbers[entry];
		
		upsDetailsWindow[entry] = new Array();
		upsDetailsWindow[entry]["Container"] = new Window("details"+entry);
		upsDetailsWindow[entry]["Container"].height = 300;
		upsDetailsWindow[entry]["Container"].width  = 300;
		upsDetailsWindow[entry]["Container"].visible = 1;

		upsDetailsWindow[entry]["BackgroundTop"] = new Image(upsDetailsWindow[entry]["Container"]);
		upsDetailsWindow[entry]["BackgroundTop"].width    = upsDetailsWindow[entry]["Container"].width;
		upsDetailsWindow[entry]["BackgroundTop"].height   = 10;
		upsDetailsWindow[entry]["BackgroundTop"].src      = "./Resources/backgroundTop.png";
		upsDetailsWindow[entry]["BackgroundTop"].colorize = preferences.bezelColor.value;

		upsDetailsWindow[entry]["BackgroundCenter"] = new Image(upsDetailsWindow[entry]["Container"]);
		upsDetailsWindow[entry]["BackgroundCenter"].width    = upsDetailsWindow[entry]["Container"].width;
		upsDetailsWindow[entry]["BackgroundCenter"].height   = 280;
		upsDetailsWindow[entry]["BackgroundCenter"].src      = "./Resources/backgroundCenter.png";
		upsDetailsWindow[entry]["BackgroundCenter"].colorize = preferences.bezelColor.value;
		upsDetailsWindow[entry]["BackgroundCenter"].vOffset  = upsDetailsWindow[entry]["BackgroundTop"].vOffset + upsDetailsWindow[entry]["BackgroundTop"].height;

		upsDetailsWindow[entry]["BackgroundBottom"] = new Image(upsDetailsWindow[entry]["Container"]);
		upsDetailsWindow[entry]["BackgroundBottom"].width    = upsDetailsWindow[entry]["Container"].width;
		upsDetailsWindow[entry]["BackgroundBottom"].height   = 10;
		upsDetailsWindow[entry]["BackgroundBottom"].src      = "./Resources/backgroundBottom.png";
		upsDetailsWindow[entry]["BackgroundBottom"].colorize = preferences.bezelColor.value;	
		upsDetailsWindow[entry]["BackgroundBottom"].vOffset  = upsDetailsWindow[entry]["BackgroundCenter"].vOffset + upsDetailsWindow[entry]["BackgroundCenter"].height;

		upsDetailsWindow[entry]["Details"] = new TextArea(upsDetailsWindow[entry]["Container"]);
		dataStr = "";
		for (items in displayedNumbers[entry]){
		$_ = displayedNumbers[entry][items]
			
			if (($_ != "Unavailable")
			  &&(items != "itemFrame") 
			  &&(items != "position")
			  &&(items != "readout"))
			{
				print(items)
				dataStr += resolveNumValue(items) +": "+$_+"\n";
			}
		}
		upsDetailsWindow[entry]["Details"].data	   = dataStr;
		upsDetailsWindow[entry]["Details"].font    = "Verdana";
		upsDetailsWindow[entry]["Details"].color   = preferences.fontColor.value;
		upsDetailsWindow[entry]["Details"].size    = 12;
		upsDetailsWindow[entry]["Details"].hOffset = 10;
		upsDetailsWindow[entry]["Details"].vOffset = 10;
		upsDetailsWindow[entry]["Details"].width   = 286;
		upsDetailsWindow[entry]["Details"].height  = 270;
		upsDetailsWindow[entry]["Details"].editable = 0;
		if (dataStr.split("\n").length > 18){
			upsDetailsWindow[entry]["Details"].scrollbar = "";
			upsDetailsWindow[entry]["Details"].scrollbar = 1;		
		} else{
			upsDetailsWindow[entry]["Details"].scrollbar = "";
			upsDetailsWindow[entry]["Details"].scrollbar = 0;
		}


		upsDetailsWindow[entry]["Close"] = new Image(upsDetailsWindow[entry]["Container"]);
		upsDetailsWindow[entry]["Close"].src       = "./Resources/closeon.png";
		upsDetailsWindow[entry]["Close"].height    = 16;
		upsDetailsWindow[entry]["Close"].width     = 16;
		upsDetailsWindow[entry]["Close"].vOffset   = upsDetailsWindow[entry]["Container"].height - 20;
		upsDetailsWindow[entry]["Close"].hOffset   = upsDetailsWindow[entry]["Container"].width - 20;
		upsDetailsWindow[entry]["Close"].tooltip   = "Close this window";
		upsDetailsWindow[entry]["Close"].onMouseDown = function(){
			upsDetailsWindow[entry]["Close"].src       = "./Resources/close.png";}
		upsDetailsWindow[entry]["Close"].onMouseUp = function(){
			upsDetailsWindow[entry]["Close"].src       = "./Resources/closeon.png";
			upsDetailsWindow[entry]["Container"].visible = 0;}		
	}

	function upsAutocheck(){
		for (items in displayedNumbers){
			
			$_ = displayedNumbers[items]; // cause I like the default value from perl.
			upsTrack($_.number, items, 1);
			
		}
	}
		url = new URL();
	function upsTrack(tNumber, entry, automatic){
		if (automatic != 1){pleaseWait();}

		url.location = "http://wwwapps.ups.com/WebTracking/processRequest?tracknum="+tNumber;
		url.entry = entry;
		url.tNumber = tNumber;
		url.automatic = automatic;
		url.fetch();
		

		
		if ((url.result.match(/<!-- Scheduled Delivery Date logic -->/))||(url.result.match(/status = "Delivered"/))){

			displayedNumbers[url.entry].readout.onMouseUp = "upsTrack(\""+url.tNumber+"\", "+url.entry+");";
			upsProcessResults(url);
		} else {
			displayedNumbers[url.entry].readout.status.src = "./Resources/exclaimation.png";
			if (url.result.match(/Unable to track/)){
				displayedNumbers[url.entry].readout.status.tooltip = "Unable to track shipment";
			} else {
				displayedNumbers[url.entry].readout.status.tooltip = "Error Retrieving Page";
			}
		}
		
	}

function upsProcessResults( url ){

	if (url.response == 200){
		if (url.result.match(/status = "Delivered";/)){
			results = url.result.split(/<!-- Begin Tracking Number Label -->/)[1];
			resultsArray = results.split(/<!-- End Summary List -->/)[0];
			
			results = results.replace(/\n/g,"");
			results = results.replace(/\s{2,100}/g, " ");
			results = results.replace(/:/g,"");
			results = results.replace(/<!-- [^>]+>/g, "");
			results = results.replace(/&nbsp;/ig, "");
			
			resultsArray = results.split(/<tr>\s*<td class="det-pad">/);
			resultsArray.shift();
			resultsArray.shift();
			
			dataArray = new Array();
			
			for (items in resultsArray){
				if(resultsArray[items].match(/\s*([^<]+)<\/td>\s*<td class="det-pad">\s*([^<]+)<\/td>\s*<td class="det-pad">\s*([^<]+)*<\/td>\s*<\/tr>/)){
					dataType = resultsArray[items].match(/\s*([^<]+)*<\/td>\s*<td class="det-pad">\s*([^<]+)*<\/td>\s*<td class="det-pad">\s*([^<]+)*<\/td>\s*<\/tr>/)[1];
					dataType = dataType.match(/(\S.*)\s/)[1];
					dataValue = resultsArray[items].match(/\s*([^<]+)*<\/td>\s*<td class="det-pad">\s*([^<]+)*<\/td>\s*<td class="det-pad">\s*([^<]+)*<\/td>\s*<\/tr>/)[2];
					dataValue = dataValue.match(/(\S.*)\s/)[1];
					dataArray[dataType] = dataValue;
					print(dataType +":"+dataValue);
				} else if(resultsArray[items].match(/\s*([^<]+)<\/td>\s*<td class="det-pad">\s*<b>([^<]+)<\/b> <\/td>\s*<td class="det-pad">\s*([^<]+)*<\/td>\s*<\/tr>/)){
					dataType = resultsArray[items].match(/\s*([^<]+)<\/td>\s*<td class="det-pad">\s*<b>([^<]+)<\/b> <\/td>\s*<td class="det-pad">\s*([^<]+)*<\/td>\s*<\/tr>/)[1];
					dataType = dataType.match(/(\S.*)\s/)[1];
					dataValue = resultsArray[items].match(/\s*([^<]+)<\/td>\s*<td class="det-pad">\s*<b>([^<]+)<\/b> <\/td>\s*<td class="det-pad">\s*([^<]+)*<\/td>\s*<\/tr>/)[2];
					dataValue = dataValue.match(/(\S.*)\s/)[1];
					dataArray[dataType] = dataValue;
					print(dataType +":"+dataValue);
				}
			}
			
//			if(dataArray.length > 0){
					for (items in dataArray){
						switch(items){
							case "Shipped to":
								displayedNumbers[url.entry].destination = dataArray[items];
								break;
							case "Shipped or Billed on":
								displayedNumbers[url.entry].shipDate = dataArray[items];
								break;
							case "Service Type":
								displayedNumbers[url.entry].serviceType = dataArray[items];
								break;
							case "Weight":
								displayedNumbers[url.entry].weight = dataArray[items];
								break;
							case "Status":
								displayedNumbers[url.entry].status = dataArray[items];
								break;
							case "Scheduled Delivery":
								displayedNumbers[url.entry].schDelivery = dataArray[items];
								break;
							case "Delivered to":
								displayedNumbers[url.entry].deliveredTo = dataArray[items];
								break;
							case "Signed by":
								displayedNumbers[url.entry].signedBy = dataArray[items];
								break;
						}
					}
//			}
			
			if(displayedNumbers[url.entry].status == "Delivered"){
				displayedNumbers[url.entry].readout.status.src = "./Resources/box.png";
				displayedNumbers[url.entry].readout.status.tooltip = "Delivered";
			} else if (displayedNumbers[url.entry].status.match("In Transit")){
				displayedNumbers[url.entry].readout.status.src = "./Resources/truck.png";
				displayedNumbers[url.entry].readout.status.tooltip = displayedNumbers[url.entry].status;
			} else if (displayedNumbers[url.entry].status.match("Pickup")){
				displayedNumbers[url.entry].readout.status.src = "./Resources/truck.png";
				displayedNumbers[url.entry].readout.status.tooltip = displayedNumbers[url.entry].status;
			} else if (displayedNumbers[url.entry].status.match("Billing")){
				displayedNumbers[url.entry].readout.status.src = "./Resources/moneybag.png";
				displayedNumbers[url.entry].readout.status.tooltip = displayedNumbers[url.entry].status;
			} else if (displayedNumbers[url.entry].status.match("Exception")){
				displayedNumbers[url.entry].readout.status.src = "./Resources/truck.png";
				displayedNumbers[url.entry].readout.status.tooltip = displayedNumbers[url.entry].status;
			}
			
			if (url.automatic != 1){upsDetails(url.entry);}	
			

		} else if ((url.result.match(/<!-- Scheduled Delivery Date logic -->/)) && (url.result.match(/<!-- Begin Web Claims Link Module  -->/))){
			resultsArray = url.result.split("<!-- Scheduled Delivery Date logic -->");
			resultsArray = resultsArray[1].split("<!-- Begin Web Claims Link Module  -->");
			results = resultsArray[0];
			results = results.replace(/\n/g,"");
			results = results.replace(/\s{2,100}/g, " ");
			results = results.replace(/:/g,"");
			
			resultsArray = results.split(/<tr>\s*<td class="det-pad">/);
			resultsArray.shift();
			resultsLength = resultsArray.length;
			resultsArray[resultsLength] = resultsArray[resultsLength-1].split(/<!-- End Multiple Labels -->/)[1];
			resultsArray[resultsLength-1] = resultsArray[resultsLength - 1].split(/<!-- End Multiple Labels -->/)[0];
			
			dataArray = new Array();
			
			for (items in resultsArray){
				dataType = "";
				dataValue = "";
				if (resultsArray[items].match(/ Status <\/td> <td class="det-pad" nowrap> <b> ([^<]+) <\/b> <\/td>/)){
					dataType="Status";
					dataValue = resultsArray[items].match(/ Status <\/td> <td class="det-pad" nowrap> <b> ([^<]+) <\/b> <\/td>/)[1];
					dataArray[dataType] = dataValue;
				}else if(resultsArray[items].match(/\s*([^<]+)<\/td>\s*<td class="det-pad">\s*([^<]+)<\/td>\s*<td class="det-pad">\s*([^<]+)<\/td>\s*<\/tr>/)){
					
					dataType = resultsArray[items].match(/\s*([^<]+)<\/td>\s*<td class="det-pad">\s*([^<]+)<\/td>\s*<td class="det-pad">\s*([^<]+)<\/td>\s*<\/tr>/)[1];
					dataType = dataType.match(/(\S.*)\s/)[1];
					dataValue = resultsArray[items].match(/\s*([^<]+)<\/td>\s*<td class="det-pad">\s*([^<]+)<\/td>\s*<td class="det-pad">\s*([^<]+)<\/td>\s*<\/tr>/)[2];
					dataValue = dataValue.match(/(\S.*)\s/)[1];
					dataArray[dataType] = dataValue;
				} else {
					if (resultsArray[items].match(/<!-- Begin Detail Title Row -->/)){
						tempData = resultsArray[items].split(/<!-- Begin Detail Title Row -->/)[1];
						tempData = tempData.split(/<!-- End Detail Rows -->/)[0];
						tempData = tempData.split(/<tr/);
						tempData[2] = tempData[2].replace(/<br>/ig, "");
						tempData[2] = tempData[2].replace(/&nbsp;/ig, "");
							if (tempData[2].match(/ <td class="sec-pad"> (.*) <\/td> <td class="sec-pad"> (.*) <\/td> <td align="right" class="sec-pad"> (.*) <\/td> <td class="sec-pad"> (.*) <\/td>/)){
								tempArray = new Array();
								tempArray = tempData[2].match(/ <td class="sec-pad"> (.*) <\/td> <td class="sec-pad"> (.*) <\/td> <td align="right" class="sec-pad"> (.*) <\/td> <td class="sec-pad"> (.*) <\/td>/);
								tempArray.shift();
								print(tempArray);
								displayedNumbers[url.entry].location = tempArray[0];
								displayedNumbers[url.entry].lastUpdateDate = tempArray[1];
								displayedNumbers[url.entry].lastUpdateTime = tempArray[2];
								displayedNumbers[url.entry].activity = tempArray[3];
							}
					}
				}
					print(dataType+":"+dataValue+":");
					
					for (items in dataArray){
						switch(items){
							case "Shipped to":
							displayedNumbers[url.entry].destination = dataArray[items];
							break;
							case "Shipped or Billed on":
							displayedNumbers[url.entry].shipDate = dataArray[items];
							break;
							case "Service Type":
							displayedNumbers[url.entry].serviceType = dataArray[items];
							break;
							case "Weight":
							displayedNumbers[url.entry].weight = dataArray[items];
							break;
							case "Status":
							displayedNumbers[url.entry].status = dataArray[items];
							break;
							case "Scheduled Delivery":
							displayedNumbers[url.entry].schDelivery = dataArray[items];
							break;
						}
					}
				
			}		
			
	if(displayedNumbers[url.entry].status == "Delivered"){
		displayedNumbers[url.entry].readout.status.src = "./Resources/box.png";
		displayedNumbers[url.entry].readout.status.tooltip = "Delivered";
	} else if (displayedNumbers[url.entry].status.match("In Transit")){
		displayedNumbers[url.entry].readout.status.src = "./Resources/truck.png";
		displayedNumbers[url.entry].readout.status.tooltip = displayedNumbers[url.entry].status;
	} else if (displayedNumbers[url.entry].status.match("Pickup")){
		displayedNumbers[url.entry].readout.status.src = "./Resources/truck.png";
		displayedNumbers[url.entry].readout.status.tooltip = displayedNumbers[url.entry].status;
	} else if (displayedNumbers[url.entry].status.match("Billing")){
		displayedNumbers[url.entry].readout.status.src = "./Resources/moneybag.png";
		displayedNumbers[url.entry].readout.status.tooltip = displayedNumbers[url.entry].status;
	} else if (displayedNumbers[url.entry].status.match("Exception")){
		displayedNumbers[url.entry].readout.status.src = "./Resources/truck.png";
		displayedNumbers[url.entry].readout.status.tooltip = displayedNumbers[url.entry].status;
	}

		
		if (url.automatic != 1){upsDetails(url.entry);}	
		
		} else {
			print("No Matches");
			displayedNumbers[url.entry].readout.status.src = "./Resources/exclaimation.png";
			displayedNumbers[url.entry].readout.status.tooltip = "Error Retrieving Page";
		}
	
	} else {
		print("url response = "+url.response);
		displayedNumbers[url.entry].readout.status.src = "./Resources/exclaimation.png";
		displayedNumbers[url.entry].readout.status.tooltip = "Error Retrieving Page";
	}


	displayedNumbers[url.entry].readout.status.reload();

}
	
function upsWebpage(tNumber){
	openURL("http://wwwapps.ups.com/WebTracking/processRequest?tracknum="+tNumber);
}